#ifndef _bw_h__included_
#define _bw_h__included_

#include <windows.h>

typedef struct bwStyleStruct_
{
	COLORREF WindowBack;
	COLORREF GroupBorder, GroupText;
	COLORREF ButtonBack, ButtonText, ButtonBorder, ButtonDisabledBack, ButtonLightBack;
	COLORREF StaticText;
	COLORREF CheckboxText, CheckboxLightText;
	COLORREF EditText;
} bwStyleStruct;

extern bwStyleStruct bwCurrentStyle;

void bwInit();

void bwInstall(HWND); // Install bw-lib on specified window (or dialog).
void bwInstall(HWND hWnd, bwStyleStruct *pSt); // install with specified style.
void bwInstallWithEffect(HWND hWnd, void (*Effect)(HWND));
void bwInstallWithEffect(HWND hWnd, bwStyleStruct *pSt, void (*Effect)(HWND));

void bwEffect_RollOut_UpDown(HWND hWnd);
void bwEffect_RollOut_LeftRight(HWND hWnd);
void bwEffect_RollOut_Center(HWND hWnd);

void bwChangeColorsOfControl(HWND hWnd, COLORREF Text, COLORREF Back);
void bwSetWindowStyle(HWND hWnd, bwStyleStruct *NewStyle);
COLORREF bwGetDlgItemColor(HWND hDlg, int id);

void bwScrollWindowSupport(HWND This, UINT Msg, WPARAM wParam, LPARAM lParam, LPRECT WinSize);
void bwCheckMaxWindowSize(HWND This);

#ifndef BW_OPTION_NO_HINTS
void bwSetHint(HWND This, int idCtrl, const char *HintStr);
void bwSetHintDisplayControl(HWND This, int idCtrl, const char *DefaultHint);
void bwChangeCurrentHint(HWND hParent, HWND hControl);
#endif

#endif // _bw_h__included_
