// this file contents controlling function for COLORS dialog.

//#ifndef DISABLE_BW
bwStyleStruct TmpStyle;
//#endif
int TmpUseWinStyle;
void (__cdecl*TmpEffect)(HWND);

RECT TTTWinSize;

BOOL CALLBACK ColorsTEST_DlgProc(HWND This, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg)
	{
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
		case IDC_CANCEL:
			EndDialog(This, 0);
			break;
		}
		break;

	case WM_SIZE:
	case WM_VSCROLL:
	case WM_HSCROLL:
		bwScrollWindowSupport(This, Msg, wParam, lParam, &TTTWinSize);
		break;

	case WM_INITDIALOG:
		GetClientRect(This, &TTTWinSize);
		bwCheckMaxWindowSize(This);
		SetLang(CurrentLang, mls_ex[CurrentLang], sizeof(mls_ex_ru)/sizeof(mls_ex_ru[0]), This);

		SetDlgItemText(This, IDC_DIR, "c:\\");
		{
			HWND hProgress = GetDlgItem(This, IDC_PROGRESS);
//#ifndef DISABLE_BW
			if (!TmpUseWinStyle)
			{
				SendMessage(hProgress, PBM_SETBKCOLOR,  0, TmpStyle.WindowBack);
				SendMessage(hProgress, PBM_SETBARCOLOR, 0, TmpStyle.GroupBorder);
			}
//#endif
			SendMessage(hProgress, PBM_SETRANGE, 0, MAKELONG(0, 3));
			SendMessage(hProgress, PBM_SETSTEP, 1, 0);
			SendMessage(hProgress, PBM_STEPIT, 0, 0);
		}
//#ifndef DISABLE_BW
		if (!TmpUseWinStyle)
		{
			if (TmpEffect) bwInstallWithEffect(This, &TmpStyle, TmpEffect);
			else bwInstall(This, &TmpStyle);
		}
//#endif
		SetDlgItemText(This, IDC_LICENSE, MLS_MSG(COLOR_EX));
		return TRUE;
	}
	return FALSE;
}

RECT ClrWinSize;

BOOL CALLBACK ColorsDlgProc(HWND This, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg)
	{
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			UserStyle.ButtonBack			= bwGetDlgItemColor(This, IDC_BUTTON_BACK);
			UserStyle.ButtonBorder			= bwGetDlgItemColor(This, IDC_BUTTON_BORDER);
			UserStyle.ButtonDisabledBack	= bwGetDlgItemColor(This, IDC_BUTTON_DISBACK);
			UserStyle.ButtonLightBack		= bwGetDlgItemColor(This, IDC_BUTTON_LIGHTBACK);
			UserStyle.ButtonText			= bwGetDlgItemColor(This, IDC_BUTTON_TEXT);
			UserStyle.CheckboxText			= bwGetDlgItemColor(This, IDC_CHECK_TEXT);
			UserStyle.CheckboxLightText		= bwGetDlgItemColor(This, IDC_CHECK_LIGHTTEXT);
			UserStyle.GroupBorder			= bwGetDlgItemColor(This, IDC_GROUP_BORDER);
			UserStyle.GroupText				= bwGetDlgItemColor(This, IDC_GROUP_TEXT);
			UserStyle.StaticText			= bwGetDlgItemColor(This, IDC_TEXT_COLOR);
			UserStyle.WindowBack			= bwGetDlgItemColor(This, IDC_WINDOW_BACK);
			UserStyle.EditText				= bwGetDlgItemColor(This, IDC_EDIT_TEXT);

			if (IsDlgButtonChecked(This, IDC_STYLE_WIN) == BST_CHECKED)
				Flags |= FLAG_STYLE_WINDOWS;
			else Flags &= ~FLAG_STYLE_WINDOWS;

			if (IsDlgButtonChecked(This, IDC_STYLE_USER) == BST_CHECKED)
				Flags |= FLAG_STYLE_USER;
			else Flags &= ~FLAG_STYLE_USER;


			if (IsDlgButtonChecked(This, IDC_ROLLOUT_UPDOWN) == BST_CHECKED)
				Flags |= FLAG_EFFECT_UPDOWN;
			else Flags &= ~FLAG_EFFECT_UPDOWN;

			if (IsDlgButtonChecked(This, IDC_ROLLOUT_LEFTRIGHT) == BST_CHECKED)
				Flags |= FLAG_EFFECT_LEFTRIGHT;
			else Flags &= ~FLAG_EFFECT_LEFTRIGHT;

			if (IsDlgButtonChecked(This, IDC_ROLLOUT_CENTER) == BST_CHECKED)
				Flags |= FLAG_EFFECT_CENTER;
			else Flags &= ~FLAG_EFFECT_CENTER;


		case IDCANCEL:
			EndDialog(This, 0);
			break;

	/*	case IDC_STYLE_DEF:
			break;

		case IDC_STYLE_WIN:
			break;

		case IDC_STYLE_USER:
			break;
	*/
		case IDC_TEST:
			// get user colors:
			if (IsDlgButtonChecked(This, IDC_STYLE_USER) == BST_CHECKED)
			{
				TmpStyle.ButtonBack			= bwGetDlgItemColor(This, IDC_BUTTON_BACK);
				TmpStyle.ButtonBorder		= bwGetDlgItemColor(This, IDC_BUTTON_BORDER);
				TmpStyle.ButtonDisabledBack	= bwGetDlgItemColor(This, IDC_BUTTON_DISBACK);
				TmpStyle.ButtonLightBack	= bwGetDlgItemColor(This, IDC_BUTTON_LIGHTBACK);
				TmpStyle.ButtonText			= bwGetDlgItemColor(This, IDC_BUTTON_TEXT);
				TmpStyle.CheckboxText		= bwGetDlgItemColor(This, IDC_CHECK_TEXT);
				TmpStyle.CheckboxLightText	= bwGetDlgItemColor(This, IDC_CHECK_LIGHTTEXT);
				TmpStyle.GroupBorder		= bwGetDlgItemColor(This, IDC_GROUP_BORDER);
				TmpStyle.GroupText			= bwGetDlgItemColor(This, IDC_GROUP_TEXT);
				TmpStyle.StaticText			= bwGetDlgItemColor(This, IDC_TEXT_COLOR);
				TmpStyle.WindowBack			= bwGetDlgItemColor(This, IDC_WINDOW_BACK);
				TmpStyle.EditText			= bwGetDlgItemColor(This, IDC_EDIT_TEXT);

				TmpUseWinStyle = FALSE;
			}
			else if (IsDlgButtonChecked(This, IDC_STYLE_WIN) == BST_CHECKED) TmpUseWinStyle = TRUE;
			else
			{
				memcpy(&TmpStyle, &bwCurrentStyle, sizeof(bwStyleStruct));
				TmpUseWinStyle = FALSE;
			}

			// Check effects:
			if (IsDlgButtonChecked(This, IDC_ROLLOUT_UPDOWN) == BST_CHECKED) TmpEffect = bwEffect_RollOut_UpDown;
			else if (IsDlgButtonChecked(This, IDC_ROLLOUT_LEFTRIGHT) == BST_CHECKED) TmpEffect = bwEffect_RollOut_LeftRight;
			else if (IsDlgButtonChecked(This, IDC_ROLLOUT_CENTER) == BST_CHECKED) TmpEffect = bwEffect_RollOut_Center;
			else TmpEffect = NULL;

			DialogBoxParam(hInstance, (LPCTSTR) IDD_COLORS_TEST, This, ColorsTEST_DlgProc, NULL);
			break;
		}
		break;

	case WM_SIZE:
	case WM_VSCROLL:
	case WM_HSCROLL:
		bwScrollWindowSupport(This, Msg, wParam, lParam, &ClrWinSize);
		break;

	case WM_INITDIALOG:
		GetClientRect(This, &ClrWinSize);
		bwCheckMaxWindowSize(This);
		SetLang(CurrentLang, mls_colors[CurrentLang], sizeof(mls_colors_ru)/sizeof(mls_colors_ru[0]), This);

		if (Flags & FLAG_STYLE_USER) CheckDlgButton(This, IDC_STYLE_USER, BST_CHECKED);
		else if (Flags & FLAG_STYLE_WINDOWS) CheckDlgButton(This, IDC_STYLE_WIN, BST_CHECKED);
		else CheckDlgButton(This, IDC_STYLE_DEF, BST_CHECKED);

		if (Flags & FLAG_EFFECT_LEFTRIGHT) CheckDlgButton(This, IDC_ROLLOUT_LEFTRIGHT, BST_CHECKED);
		else if (Flags & FLAG_EFFECT_UPDOWN) CheckDlgButton(This, IDC_ROLLOUT_UPDOWN, BST_CHECKED);
		else if (Flags & FLAG_EFFECT_CENTER) CheckDlgButton(This, IDC_ROLLOUT_CENTER, BST_CHECKED);
		else CheckDlgButton(This, IDC_NO_EFFECTS, BST_CHECKED);

		bwInstall(This);

		bwChangeColorsOfControl(GetDlgItem(This, IDC_WINDOW_BACK), UserStyle.WindowBack, UserStyle.WindowBack);

		bwChangeColorsOfControl(GetDlgItem(This, IDC_EDIT_TEXT), UserStyle.EditText, UserStyle.EditText);

		bwChangeColorsOfControl(GetDlgItem(This, IDC_BUTTON_TEXT), UserStyle.ButtonText, UserStyle.ButtonText);
		bwChangeColorsOfControl(GetDlgItem(This, IDC_BUTTON_BORDER), UserStyle.ButtonBorder, UserStyle.ButtonBorder);
		bwChangeColorsOfControl(GetDlgItem(This, IDC_BUTTON_BACK), UserStyle.ButtonBack, UserStyle.ButtonBack);
		bwChangeColorsOfControl(GetDlgItem(This, IDC_BUTTON_LIGHTBACK), UserStyle.ButtonLightBack, UserStyle.ButtonLightBack);
		bwChangeColorsOfControl(GetDlgItem(This, IDC_BUTTON_DISBACK), UserStyle.ButtonDisabledBack, UserStyle.ButtonDisabledBack);

		bwChangeColorsOfControl(GetDlgItem(This, IDC_CHECK_TEXT), UserStyle.CheckboxText, UserStyle.CheckboxText);
		bwChangeColorsOfControl(GetDlgItem(This, IDC_CHECK_LIGHTTEXT), UserStyle.CheckboxLightText, UserStyle.CheckboxLightText);

		bwChangeColorsOfControl(GetDlgItem(This, IDC_GROUP_TEXT), UserStyle.GroupText, UserStyle.GroupText);
		bwChangeColorsOfControl(GetDlgItem(This, IDC_GROUP_BORDER), UserStyle.GroupBorder, UserStyle.GroupBorder);

		bwChangeColorsOfControl(GetDlgItem(This, IDC_TEXT_COLOR), UserStyle.StaticText, UserStyle.StaticText);

		return TRUE;
	}
	return FALSE;
}
