//-----------------------------------------------------------------------------
// M-INSTALLER: VERSION 3.7
//
// (C) 2005-2007, Alexander G. Karpov a.k.a. mrhx.
//
//-----------------------------------------------------------------------------

//#define DISABLE_BW
#define FULL_VERSION

#define DO_NOT_INCLUDE_STD
#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include "resource.h"
#include "sixpack.c"
//#ifndef DISABLE_BW
  #include "bw.h"
  #include "bw.cpp"
//#endif
#include "installing module/array_lite.c"
#include "installing module/array_full.c"
#include "uninst/array.c"
#include "uninst_en/array.c"
#include "array_icon.c"

//-----------------------------------------------------------------------------
// LINK&COMPILE OPTIONS.
//-----------------------------------------------------------------------------

#pragma comment(linker,"/NODEFAULTLIB")
#pragma comment(linker,"/ENTRY:main")
#pragma comment(linker,"/FILEALIGN:512")
//#pragma comment(linker,"/MERGE:.data=.text")
//#pragma comment(linker,"/MERGE:.rdata=.text")
//#pragma comment(linker,"/SECTION:.text,ERWX")
//#pragma comment(linker,"/IGNORE:4078")

//-----------------------------------------------------------------------------
// DEFINES.
//-----------------------------------------------------------------------------

#define LOGFILE		"mInstaller.log"
#define VERSION_NUM	"3.7"
//#ifdef FULL_VERSION
//#define VERSION		VERSION_NUM##" Full"
//#else
//#define VERSION		VERSION_NUM##" Lite"
//#endif
#define VERSION		VERSION_NUM

#include "lang.h"


//-----------------------------------------------------------------------------
// TAGS FOR SETUP DATA:
//-----------------------------------------------------------------------------

#define TAG_SIGNATURE			'XHRM'
#define TAG_DIR					1
#define TAG_FILE				3
#define TAG_DIR_END				9
#define TAG_END					63

//   :    .
//        windows.

//    2.0         ,
//   .      2.0 .

/*
	SETUP DATA FORMAT:
		
		SIGNATURE
		FLAGS				<-- IN 2.0
		GUI-STYLE			<-- IN 2.0 if FLAG_STYLE_USER

		

		LICENSE
		PROGNAME			<-- in v2.5
		PRODUCER			<-- in 3.5
		UNINST_CODE			<-- v2.5, if FLAG_UNINST.
		LINKS-DESKTOP
		LINKS-PROGRAMS
		LINKS-QUICK_LAUNCH
		LINKS-SENDTO
		LINKS-STARTUP
		LINKS-START_MENU
		DEFAULT-INSTALL-PATH
		EXECUTE-LINE
		INSTALL-SIZE
		COUNT_OF_OBJECTS
		OBJECTS


	NEW IN V. 1.4:
	1)	EXTENDED FORMAT OF LINK TEXT:
			FILE_NAME/LINK_FILE_NAME/LINK_DESCRIPTION

		OLD FORMAT:
			FILE_NAME

	2)	EXECUTE-LINE:
			LIST OF ITEMS TO RUN AFTER INSTALLING.

	3)	DEFAULT INSTALL PATH:
			IT WAS PROGRAM_FILES BEFORE.

	4)	INSTALL-SIZE
			Approximate size of all installation files.

	5)	OPEN & SAVE PROJECT.


	NEW IN v1.5:
	1) More licenses available, but as *.mip projects.
	2) Ask for overwrite existent files while installing.
	3) Ask for agreement with license while installing.
	4) Show size of files in bytes or Kbytes or Mbytes (not only in Kbytes).
	5) Show free size on specified disk.

	NEW IN 2.0:
	1) user-defined style of installer.
	2) separated installing module. now it's smaller than before.
	3) GUI looks better (highlight controls).

*/

//-----------------------------------------------------------------------------
// PROTOTYPES.
//-----------------------------------------------------------------------------

void __fastcall _(int code, char *msg);
char * __fastcall GetMem(unsigned int size);
BOOL CALLBACK Main(HWND, UINT, WPARAM, LPARAM);
void ProcessObj(char * name);
void OpenLog();
void CloseLog();
void __fastcall Log(char * msg);
void __fastcall Log(char *msg0, unsigned int i);

HWND hProgress;
DWORD TimeStart; // time of operation start.

//-----------------------------------------------------------------------------
// MAIN FUNCTION.
//-----------------------------------------------------------------------------

#define FLAG_STYLE_WINDOWS			0x00000001	// If gui will have default windows style.
#define FLAG_EFFECT_UPDOWN			0x00000002
#define FLAG_EFFECT_LEFTRIGHT		0x00000004
#define FLAG_EFFECT_CENTER			0x00000008
#define FLAG_STYLE_USER				0x00000010

#define FLAG_UNINST					0x00001000	// Need uninstaller.

#define FLAG_CHECK_DESKTOP			0x00010000
#define FLAG_CHECK_STARTMENU		0x00020000
#define FLAG_CHECK_PROGRAMS			0x00040000
#define FLAG_CHECK_STARTUP			0x00080000
#define FLAG_CHECK_QUICKLAUNCH		0x00100000
#define FLAG_CHECK_SENDTO			0x00200000

#define FLAG_ILANG_TWO				0x10000000	// If two installer languages available and need to choose one.
#define FLAG_PASSWORD				0x20000000	// if password needed.
#define FLAG_MENU_FOLDER			0x40000000	// if menu folder exists.


HINSTANCE hInstance = NULL;

#ifdef FULL_VERSION
bwStyleStruct UserStyle;
#endif
DWORD Flags = FLAG_STYLE_WINDOWS;

char HomePath[MAX_PATH];

void main()
{
	GetCurrentDirectory(MAX_PATH, HomePath);
	OpenLog();
	InitCommonControls();
	hInstance = GetModuleHandle(NULL);
#ifdef FULL_VERSION
	bwInit();
	memcpy(&UserStyle, &bwCurrentStyle, sizeof(bwStyleStruct));
#endif
	DialogBoxParam(hInstance, (LPCTSTR) IDD_MAIN, NULL, Main, NULL);
	CloseLog();
	ExitProcess(0);
}

//-----------------------------------------------------------------------------
// MEMORY ALLOCATION.
//-----------------------------------------------------------------------------

char * __fastcall GetMem(unsigned int size)
{
	void * ptr = LocalAlloc(LMEM_FIXED, size+1);
	_(!ptr, MLS_MSG(MEM));
	return (char *) ptr;
}

//-----------------------------------------------------------------------------
// ERROR PROCESSING.
//-----------------------------------------------------------------------------

void __fastcall _(int code, char *msg)
{
	if (code)
	{
		MessageBox(NULL, msg, MLS_MSG(TITLE1), MB_ICONERROR | MB_TOPMOST);
		ExitProcess(1);
	}
}

void __fastcall _(int code, char *msg, char *msg1)
{
	if (code)
	{
		char tmp [512];
		_(code, lstrcat(lstrcpy(tmp, msg), msg1));
	}
}

//-----------------------------------------------------------------------------
// GET WINDOW TEXT:
//-----------------------------------------------------------------------------

char * __fastcall get_text(HWND hWnd)
{
	int size = GetWindowTextLength(hWnd) + 1;
	char * text = GetMem(size);
	GetWindowText(hWnd, text, size);
	return text;
}

char * __fastcall get_text(HWND hWnd, int id)
{
	return get_text(GetDlgItem(hWnd, id));
}

//-----------------------------------------------------------------------------
// LOG SUPPORT.
//-----------------------------------------------------------------------------

HANDLE hLog;

void OpenLog()
{
	hLog = CreateFile(LOGFILE, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
}

void CloseLog()
{
	CloseHandle(hLog);
}

void __fastcall Log(char * msg)
{
	DWORD d;
	WriteFile(hLog, msg, lstrlen(msg), &d, NULL);
	WriteFile(hLog, "\r\n", 2, &d, NULL);
}

void __fastcall Log(char * msg0, const char * msg1)
{
	char buf [512];
	Log(lstrcat(lstrcpy(buf, msg0), msg1));
}

void __fastcall Log(char *msg0, unsigned int i)
{
	char buf [32];
	wsprintf(buf, "%u [0x%08X]", i, i);
	Log(msg0, buf);
}

//-----------------------------------------------------------------------------
// FILE HANDLE FOR TARGET SETUP PROGRAM.
//-----------------------------------------------------------------------------

HANDLE hSetup;

//-----------------------------------------------------------------------------
// ACTIONS WITH SETUP FILE:
//-----------------------------------------------------------------------------

typedef unsigned char UBYTE;

void crypt(UBYTE *data, ULONG len) // En/De-crypt data.
{
	register UBYTE *p = data;
	register ULONG n = len;
	for (; n; --n, ++p) *p ^= (UBYTE)(n & 0xFF);
}

void __fastcall write_data(void *ptr, unsigned int size)
{
	DWORD d;
	crypt((UBYTE*) ptr, size);
	_(!WriteFile(hSetup, ptr, size, &d, NULL), MLS_MSG(WRITE_INST));
	crypt((UBYTE*) ptr, size);
}

void __fastcall write_data_simple(void *ptr, unsigned int size)
{
	DWORD d;
	_(!WriteFile(hSetup, ptr, size, &d, NULL), MLS_MSG(WRITE_INST));
}

void __fastcall write_char_data(char data)
{
	write_data(&data, 1);
}

void __fastcall write_int_data(unsigned int data)
{
	write_data(&data, 4);
}

void __fastcall write_str_data(char *str)
{
	int len = lstrlen(str);
	write_int_data(len);
	write_data(str, len);
}

void set_data_pos(LONG Move, DWORD Method)
{
	_(0xFFFFFFFF == SetFilePointer(hSetup, Move, NULL, Method), MLS_MSG(FILE_PTR));
}

//-----------------------------------------------------------------------------
// CHANGE DIR:
//-----------------------------------------------------------------------------
void __fastcall cd(const char *dir)
{
	if (!SetCurrentDirectory(dir)) Log("FAIL cd ", dir);
}

//-----------------------------------------------------------------------------
// PROCESS ONE SOURCE FILE.
//
// FORMAT:
//
//   TAG_FILE  [1]
//   LENGTH    [4]
//   FILE_NAME [LENGTH]
//   FILE_SIZE [4]
//   COMP_SIZE [4]
//   FILE_DATA [COMP_SIZE]
//
//-----------------------------------------------------------------------------

#define FILE_PREFIX_NULL	0
#define FILE_PREFIX_STORE	1

void ProcessFile(char * fname)
{
	Log("F ", fname);

	//-----------------------------------------------------------------------------
	// OPEN SOURCE FILE:
	//-----------------------------------------------------------------------------
	HANDLE hFile = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	_(hFile == INVALID_HANDLE_VALUE, MLS_MSG(FILE_OPEN), fname);
	unsigned int size1 = GetFileSize(hFile, NULL);
	char *p1 = GetMem(size1);

	//-----------------------------------------------------------------------------
	// READ SOURCE FILE DATA:
	//-----------------------------------------------------------------------------
	DWORD d;
	_(!ReadFile(hFile, p1, size1, &d, NULL), MLS_MSG(FILE_READ), fname);

	// COMPRESS DATA:
	char *p = GetMem(size1);
	STREAM s_in, s_out;
	stream_init_mem(&s_in, (unsigned char *) p1, size1, STREAM_READ);
	stream_init_mem(&s_out, (unsigned char *) p, size1, STREAM_WRITE);
	encode(&s_in, &s_out);
	ULONG size = bytes_out;
	unsigned char file_prefix = FILE_PREFIX_NULL;

	if (size >= size1)
	{
		size = size1;
		memcpy(p, p1, size1);
		file_prefix = FILE_PREFIX_STORE;
	}

	{
		char msg [32];
		wsprintf(msg, "R%i %i%%", file_prefix, (size>=size1)?100:((size*100)/size1));
		Log(msg);
	}

	//-----------------------------------------------------------------------------
	// SAVE FILE DATA INTO SETUP:
	//-----------------------------------------------------------------------------
	write_char_data(TAG_FILE);				// WRITE FILE TAG.
	write_char_data(file_prefix);
	write_str_data(fname);
	write_int_data(size1);					// WRITE FILE DATA SIZE.
	if (!(file_prefix & FILE_PREFIX_STORE)) write_int_data(size); // WRITE COMPRESSED DATA SIZE. (only if it was compressed).
	write_data(p, size);					// WRITE FILE COMPRESSED DATA.

	//-----------------------------------------------------------------------------
	// FREE ALLOCATED BEFORE MEMORY:
	//-----------------------------------------------------------------------------
	LocalFree(p);
	LocalFree(p1);
	CloseHandle(hFile);
}

//-----------------------------------------------------------------------------
// PROCESS WHOLE SOURCE DIRECTORY.
//
// FORMAT:
//
//   TAG_DIR     [1]
//   LENGTH      [4]
//   DIR_NAME    [LENGTH]
//   FILES       [M]
//   TAG_END_DIR [1]
//
//-----------------------------------------------------------------------------

void ProcessDir(char * dirname)
{
	WIN32_FIND_DATA fd;

	Log("D ", dirname);

	HANDLE hFind = FindFirstFile("*", &fd);

	//-----------------------------------------------------------------------------
	// SAVE DIRECTORY INFO INTO TARGET SETUP DATA:
	//-----------------------------------------------------------------------------
	//int len = lstrlen(dirname);
	write_char_data(TAG_DIR);		// WRITE DIRECTORY TAG.
	//write_int_data(len);			// WRITE DIR NAME LENGTH.
	//write_data(dirname, len);		// WRITE DIRECTORY NAME WITH ZERO SYMBOL.
	write_str_data(dirname);

	if (hFind == INVALID_HANDLE_VALUE) goto END_OF_DIR;

	//-----------------------------------------------------------------------------
	// FIND AND SAVE DIRECTORY OBJECTS:
	//-----------------------------------------------------------------------------
	do
		ProcessObj(fd.cFileName);

	while(FindNextFile(hFind, &fd));

	FindClose(hFind);

END_OF_DIR:
	//-----------------------------------------------------------------------------
	// WRITE END OF DIRECTORY:
	//-----------------------------------------------------------------------------
	write_char_data(TAG_DIR_END);

	Log("END");
}

//-----------------------------------------------------------------------------
// PROCESS OBJECT (PROCESS FILE OR DIRECTORY)
//-----------------------------------------------------------------------------

void ProcessObj(char * name)
{
	DWORD attrs = GetFileAttributes(name);

	SendMessage(hProgress, PBM_STEPIT, 0, 0);

	_(attrs == 0xFFFFFFFF, MLS_MSG(FILE_ATTR), name);

	if (!lstrcmp(name, ".") || !lstrcmp(name, "..")) Log("SKIP ", name);
	else if (attrs & FILE_ATTRIBUTE_DIRECTORY)
	{
		cd(name);	// ENTER DIRECTORY.
		ProcessDir(name);					// PROCESS DIRECTORY.
		cd("..");   // EXIT DIRECTORY.
	}
	else ProcessFile(name);
}

//-----------------------------------------------------------------------------
// COUNT DIRECTORY OBJECTS:
//-----------------------------------------------------------------------------

unsigned int CountDir(unsigned int *Size)
{
	WIN32_FIND_DATA fd;
	HANDLE hFind = FindFirstFile("*", &fd);
	unsigned int count = 0;
	if (hFind == INVALID_HANDLE_VALUE) return count;
	do
	{
		++count;
		*Size += fd.nFileSizeLow;
		if (fd.nFileSizeHigh) Log("BIG FILE ", fd.cFileName);
		if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) &&
			lstrcmp(fd.cFileName, ".") && lstrcmp(fd.cFileName, ".."))
		{
			cd(fd.cFileName);
			count += CountDir(Size);
			cd("..");
		}
	}
	while(FindNextFile(hFind, &fd));
	FindClose(hFind);
	return count;
}

unsigned int CountObjects(char *dir, unsigned int *Size)
{
	cd(dir);
	unsigned int n = CountDir(Size);
	Log("COUNT ", n);
	Log("SIZE ", *Size);
	return n;
}

//-----------------------------------------------------------------------------
// ACTIONS BEFORE SETUP PROGRAM CREATION.
//-----------------------------------------------------------------------------

BOOL BeforeCreateSetup(HWND This)
{
	Log("START");
	TimeStart = GetTickCount();
	//-----------------------------------------------------------------------------
	// OPEN SETUP FILE:
	//-----------------------------------------------------------------------------
	OPENFILENAME	ofn;
	TCHAR			buf [MAX_PATH];

	*buf = 0;
	ZeroMemory(&ofn, sizeof ofn);
	ofn.lStructSize	= sizeof ofn;
	ofn.Flags		= OFN_EXPLORER | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrFilter = "Exe Files (*.exe)\0*.exe\0All Files (*.*)\0*.*\0";
	ofn.lpstrFile	= buf;
	ofn.nMaxFile	= MAX_PATH;
	ofn.lpstrTitle	= MLS_MSG(SAVE_INST);
	ofn.lpstrDefExt	= "exe";
	ofn.hwndOwner	= This;

	if (!GetSaveFileName(&ofn)) return FALSE;

	Log("dest-file: ", buf);

	hSetup = CreateFile(buf, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
	_(hSetup == INVALID_HANDLE_VALUE, MLS_MSG(NEW_INST));
	//-----------------------------------------------------------------------------
	// WRITE mInstaller installing module INTO SETUP FILE:
	//-----------------------------------------------------------------------------
	set_data_pos(0, FILE_BEGIN);
	if (Flags & FLAG_STYLE_WINDOWS) write_data_simple(array_lite, sizeof(array_lite));
	else write_data_simple(array_full, sizeof(array_full));
	//-----------------------------------------------------------------------------
	// WRITE SIGNATURE:
	//-----------------------------------------------------------------------------
	int sign = TAG_SIGNATURE;
	write_data(&sign, 4);
	return TRUE;
}

//-----------------------------------------------------------------------------
// CODE TO WRITE INTO SETUP DATA LICENSE TEXT:
//
// FORMAT:
//
//   LENGTH		 [4]
//   COMP_LEN    [4]
//   LICENSE     [COMP_LEN]
//
//-----------------------------------------------------------------------------

void WriteLicense(char * license)
{
	Log("LICENSE");
	Log(license);
	int len = lstrlen(license);
	UBYTE *buf = (UBYTE*) GetMem(len);
	STREAM s_in, s_out;
	stream_init_mem(&s_in, (unsigned char *) license, len, STREAM_READ);
	stream_init_mem(&s_out, buf, len, STREAM_WRITE);
	encode(&s_in, &s_out);
	int comp_len = bytes_out;

	if (comp_len >= len)
	{
		comp_len = len;
		memcpy(buf, license, len);
	}

	//-----------------------------------------------------------------------------
	// WRITE LICENSE INTO SETUP DATA:
	//-----------------------------------------------------------------------------
	write_int_data(len);					// WRITE LENGTH OF LICENSE.
	write_int_data(comp_len);				// WRITE COMPRESSED LENGTH.
	write_data(buf, comp_len);				// WRITE COMPRESSED LICENSE TEXT.

	LocalFree(buf);
	Log("END");
}

//-----------------------------------------------------------------------------
// WRITE NAMES OF FILES TO BE LINKS:
//
// FORMAT:
//
//   LENGTH            [4]
//   NAMES             [LENGTH]
//
//-----------------------------------------------------------------------------

void DoWriteLinks(char * links, char *Msg)
{
	Log(Msg, links);
	write_str_data(links);
}

//-----------------------------------------------------------------------------
// ACTIONS AFTER SETUP PROGRAM CREATED.
//-----------------------------------------------------------------------------



void AfterCreateSetup(HWND This)
{
	write_char_data(TAG_END);		// WRITE END OF DATA.
	// :::CHANGE INSTALLER ICON:::
	{
		Log("start icon changing...");
		// find start of icon: signature 0x00000028, 0x00000020, 0x00000040
		const stw = ( sizeof(array_icon) - 0x16 );
		unsigned char *array = (Flags & FLAG_STYLE_WINDOWS)?array_lite:array_full;
		int i = 0;
		for (; !( *(long*)(array+i+0) == 0x00000028 &&
				  *(long*)(array+i+4) == 0x00000020 &&
				  *(long*)(array+i+8) == 0x00000040); ++i);

		Log("icon resource offset: ", i);
		set_data_pos(i, FILE_BEGIN);

		Log("size of default icon: ", sizeof(array_icon));

		char iconfile [MAX_PATH];
		GetDlgItemText(This, IDC_ICONPATH, iconfile, MAX_PATH-1);

		Log("new icon file: ", iconfile);

		HANDLE hiconf = CreateFile(iconfile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hiconf == INVALID_HANDLE_VALUE)
		{ // write default icon:
			write_data_simple(array_icon+0x16, stw);
		}
		else
		{ // write user icon:
			char buff[2048];
			DWORD tmp;
			if (ReadFile(hiconf, buff, sizeof(array_icon), &tmp, NULL))
			{
				write_data_simple(buff+0x16, stw);
			}
			else
			{
				MessageBox(NULL, MLS_MSG(READ_ICON), MLS_MSG(TITLE1), MB_ICONWARNING | MB_TOPMOST);
				write_data_simple(array_icon+0x16, stw);
			}
			CloseHandle(hiconf);
		}
	}
	//-----------------------------------------------------------------------------
	// CLOSE SETUP FILE:
	//-----------------------------------------------------------------------------
	CloseHandle(hSetup);

	Log("TIME ", (GetTickCount() - TimeStart) / 1000);
	Log("FINISH");
}

//-----------------------------------------------------------------------------
// CREATE SETUP.
//-----------------------------------------------------------------------------

void CreateSetup(char * dir)
{
	cd(dir);		// SET CURRENT WORKING DIRECTORY.
	Log("PATH ", dir);

	char title [MAX_PATH];
	_(0 != GetFileTitle(dir, title, MAX_PATH), MLS_MSG(BAD_PATH), dir);

	ProcessDir(title);				// PROCESS DIRECTORY.
}

//-----------------------------------------------------------------------------
// FUNCTION TO CHOOSE DIRECTORY.
//-----------------------------------------------------------------------------
#ifndef DISABLE_BW
int CALLBACK BrowseCallbackProc(HWND This, UINT Msg, LPARAM lParam, LPARAM Data)
{
	if (Msg == BFFM_INITIALIZED) bwInstall(This);
	return 0;
}
#endif
BOOL ChooseFolder(HWND hOwner, LPTSTR pszPath, LPCTSTR Caption)
{
	BROWSEINFO bi;
	LPITEMIDLIST pidl;
	LPMALLOC pMalloc;
	BOOL Res = FALSE;

	if (SUCCEEDED(SHGetMalloc(&pMalloc)))
	{
		bi.hwndOwner		= hOwner;
		bi.pidlRoot			= NULL;
		bi.pszDisplayName	= pszPath;
		bi.lpszTitle		= Caption;
		bi.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_EDITBOX;
#ifndef DISABLE_BW
		bi.lpfn				= BrowseCallbackProc;
#else
		bi.lpfn				= NULL;
#endif

		if (pidl = SHBrowseForFolder(&bi))
		{
			Res = SHGetPathFromIDList(pidl, pszPath);
			pMalloc->Free(pidl);
		}
		pMalloc->Release();
	}
	return Res;
}

//-----------------------------------------------------------------------------
// WRITE FILES TO MAKE LINKS FROM IT:
//-----------------------------------------------------------------------------

void WriteLinks(HWND This, int Id, char *Msg)
{
	char * names = get_text(This, Id);
	DoWriteLinks(names, Msg);
	LocalFree(names);
}

//-----------------------------------------------------------------------------
// THREAD TO MAKE SETUP:
//-----------------------------------------------------------------------------

DWORD WINAPI SetupMakeThread(LPVOID p)
{
	HWND This = (HWND) p;

	//-----------------------------------------------------------------------------
	// DISABLE CONTROLS:
	//-----------------------------------------------------------------------------
	EnableWindow(GetDlgItem(This, IDC_OK), FALSE);
	ShowWindow(GetDlgItem(This, IDC_PROGRESS), SW_SHOW);

	//-----------------------------------------------------------------------------
	// BEGIN SETUP CREATION:
	//-----------------------------------------------------------------------------
	if (BeforeCreateSetup(This)) {

		int ilang_ru, ilang_en;

	//-----------------------------------------------------------------------------
	// WRITE FLAGS:
	//-----------------------------------------------------------------------------
	if (BST_CHECKED == IsDlgButtonChecked(This, IDC_CHECK_DESKTOP)) Flags |= FLAG_CHECK_DESKTOP;
	if (BST_CHECKED == IsDlgButtonChecked(This, IDC_CHECK_PROGRAMS)) Flags |= FLAG_CHECK_PROGRAMS;
	if (BST_CHECKED == IsDlgButtonChecked(This, IDC_CHECK_QUICKLAUNCH)) Flags |= FLAG_CHECK_QUICKLAUNCH;
	if (BST_CHECKED == IsDlgButtonChecked(This, IDC_CHECK_SENDTO)) Flags |= FLAG_CHECK_SENDTO;
	if (BST_CHECKED == IsDlgButtonChecked(This, IDC_CHECK_STARTUP)) Flags |= FLAG_CHECK_STARTUP;
	if (BST_CHECKED == IsDlgButtonChecked(This, IDC_CHECK_STARTMENU)) Flags |= FLAG_CHECK_STARTMENU;

	if (BST_CHECKED == IsDlgButtonChecked(This, IDC_UNINST)) Flags |= FLAG_UNINST;

	ilang_en = (BST_CHECKED == IsDlgButtonChecked(This, IDC_ILANG_EN));
	ilang_ru = (BST_CHECKED == IsDlgButtonChecked(This, IDC_ILANG_RU));

	if (ilang_ru && ilang_en) Flags |= FLAG_ILANG_TWO;

	if (GetWindowTextLength(GetDlgItem(This, IDC_PASSWD))) Flags |= FLAG_PASSWORD;
	if (GetWindowTextLength(GetDlgItem(This, IDC_MENU_FOLDER))) Flags |= FLAG_MENU_FOLDER;

	write_int_data(Flags);

	//-----------------------------------------------------------------------------
	// WRITE USER GUI STYLE:
	//-----------------------------------------------------------------------------
#ifndef DISABLE_BW
	if (Flags & FLAG_STYLE_USER) write_data(&UserStyle, sizeof(bwStyleStruct));
#endif
	// WRITE MESSAGES: (ru , en or both)
	{
		int ii;

		if (ilang_en) for (ii = 0; ii < MLS_COUNT; ++ii)
		{
			write_str_data(mls_en[ii]);
		}

		if (ilang_ru) for (ii = 0; ii < MLS_COUNT; ++ii)
		{
			write_str_data(mls_ru[ii]);
		}
	}

	// WRITE PASSWORD, if any:
	if (Flags & FLAG_PASSWORD)
	{
		char *passwd = get_text(This, IDC_PASSWD);
		write_str_data(passwd);
		LocalFree(passwd);
	}

	if (Flags & FLAG_MENU_FOLDER)
	{
		char *fold = get_text(This, IDC_MENU_FOLDER);
		write_str_data(fold);
		LocalFree(fold);
	}

	//-----------------------------------------------------------------------------
	// WRITE LICENSE:
	//-----------------------------------------------------------------------------
	{
		char * license = get_text(This, IDC_LICENSE);
		WriteLicense(license);
		LocalFree(license);
	}

	// Write program name:
	{
		char *progname = get_text(This, IDC_PROGNAME);
		write_str_data(progname);
		LocalFree(progname);
	}

	// Write producer name:
	{
		char *name = get_text(This, IDC_PRODUCER);
		write_str_data(name);
		LocalFree(name);
	}

	// Write uninstalling code.
	if (Flags & FLAG_UNINST)
	{
		if (ilang_en)
		{
			write_int_data(sizeof(array_uninst_en));
			write_data(array_uninst_en, sizeof(array_uninst_en));
		}
		if (ilang_ru)
		{
			write_int_data(sizeof(array_uninst));
			write_data(array_uninst, sizeof(array_uninst));
		}
	}

	//-----------------------------------------------------------------------------
	// WRITE NAMES FOR FILES FOR LINKS:
	//-----------------------------------------------------------------------------
	WriteLinks(This, IDC_LINKS_DESKTOP,		 "DESKTOP-LNK ");
	WriteLinks(This, IDC_LINKS_PROGRAMS,	 "PROGRAMS-LNK ");
	WriteLinks(This, IDC_LINKS_QUICK_LAUNCH, "QUICKLAUNCH-LNK ");
	WriteLinks(This, IDC_LINKS_SENDTO,		 "SENDTO-LNK ");
	WriteLinks(This, IDC_LINKS_STARTUP,		 "STARTUP-LNK ");
	WriteLinks(This, IDC_LINKS_START_MENU,	 "STARTMENU-LNK ");

	//-----------------------------------------------------------------------------
	// WRITE DEFAULT INSTALL PATH:
	//-----------------------------------------------------------------------------
	WriteLinks(This, IDC_DEFAULT_INSTALL_PATH, "INSTALL-TO ");

	//-----------------------------------------------------------------------------
	// WRITE EXECUTE LINE:
	//-----------------------------------------------------------------------------
	WriteLinks(This, IDC_RUN_LIST, "RUN-LN ");

	//-----------------------------------------------------------------------------
	// WRITE ALL THE FILES:
	//-----------------------------------------------------------------------------
	{
		char * dir = get_text(This, IDC_DIR);
		unsigned int Size = 0;
		unsigned int count = CountObjects(dir, &Size);
		//-----------------------------------------------------------------------------
		// WRITE SIZE OF ALL FILES:
		//-----------------------------------------------------------------------------
		write_int_data(Size);
		//-----------------------------------------------------------------------------
		// WRITE COUNT OF OBJECTS:
		//   COUNT     [4]
		//-----------------------------------------------------------------------------
		write_int_data(count);
		//-----------------------------------------------------------------------------
		SendMessage(hProgress, PBM_SETRANGE, 0, MAKELONG(0, count));
		CreateSetup(dir);
		LocalFree(dir);
	}

	//-----------------------------------------------------------------------------
	// END SETUP CREATION:
	//-----------------------------------------------------------------------------
	AfterCreateSetup(This);

	MessageBox(This, MLS_MSG(DONE), MLS_MSG(TITLE1), MB_ICONINFORMATION|MB_TOPMOST);

	SendMessage(hProgress, PBM_SETPOS, 0, 0);

	} // BeforeCreateSetup

	EnableWindow(GetDlgItem(This, IDC_OK), TRUE);
	ShowWindow(GetDlgItem(This, IDC_PROGRESS), SW_HIDE);

	return 0;
}

#include "help.h"
#include "proj.h"
#ifdef FULL_VERSION
  #include "colors.h"
#endif

//-----------------------------------------------------------------------------
// MAIN DIALOG FUNCTION.
//-----------------------------------------------------------------------------

RECT WinSize;

BOOL CALLBACK Main(HWND This, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg)
	{
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_OK:
			if (BST_CHECKED != IsDlgButtonChecked(This, IDC_ILANG_RU) &&
				BST_CHECKED != IsDlgButtonChecked(This, IDC_ILANG_EN))
				MessageBox(This, MLS_MSG(CHOOSE_A_LANG), MLS_MSG(TITLE1), MB_OK | MB_ICONWARNING);

			else
			{
				DWORD th_id;

				if (!CreateThread(NULL, 0, SetupMakeThread, (LPVOID) This, 0, &th_id))
				{
					Log("NO THREAD");
					SetupMakeThread((LPVOID) This);
				}
			}
			break;

		case IDCANCEL:
			if (IDYES == MessageBox(This, MLS_MSG(EXIT), MLS_MSG(TITLE1), MB_ICONQUESTION|MB_YESNO))
				EndDialog(This, 0);
			break;

		//-----------------------------------------------------------------------------
		// CHOOSE DIRECTORY WITH SOURCE FILES:
		//-----------------------------------------------------------------------------
		case IDC_CHOOSE:
			{
				char dir [MAX_PATH];

				if (ChooseFolder(This, dir, MLS_MSG(CHOOSE_DIR)))
					SetDlgItemText(This, IDC_DIR, dir);
			}
			break;

		case IDC_CH_ICONPATH:
			{
				OPENFILENAME ofn;
				char iconfile [MAX_PATH];

				*iconfile = 0;
				ZeroMemory(&ofn, sizeof ofn);
				ofn.lStructSize	= sizeof ofn;
				ofn.Flags		= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_READONLY;
				ofn.lpstrFilter = "Icon Files (*.ico)\0*.ico\0";
				ofn.lpstrFile	= iconfile;	
				ofn.nMaxFile	= MAX_PATH;
				ofn.lpstrTitle	= MLS_MSG(CH_ICON);
				ofn.lpstrDefExt	= "ico";
				ofn.hwndOwner	= This;

				if (GetOpenFileName(&ofn))
				{
					SetDlgItemText(This, IDC_ICONPATH, iconfile);
				}
			}
			break;

		case IDC_ICONPATH:
			if (HIWORD(wParam) == EN_CHANGE)
			{
				char iconfile [MAX_PATH];
				GetDlgItemText(This, IDC_ICONPATH, iconfile, MAX_PATH-1);
				HICON hicon = (HICON) LoadImage(hInstance, iconfile, IMAGE_ICON, 0, 0, LR_DEFAULTSIZE|LR_LOADFROMFILE);
				if (!hicon) hicon = LoadIcon(hInstance, (LPCTSTR) IDI_INST);
				else
				{
					HANDLE hif = CreateFile(iconfile, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
					DWORD sz = GetFileSize(hif, NULL);
					CloseHandle(hif);
					if (sz != sizeof(array_icon))
					{
						MessageBox(This, MLS_MSG(BAD_ICON), MLS_MSG(TITLE1), MB_OK|MB_ICONWARNING);
						SetDlgItemText(This, IDC_ICONPATH, MLS_MSG(IICO));
						break;
					}
				}
				SendDlgItemMessage(This, IDC_PROGICON, STM_SETICON, (WPARAM) hicon, 0);
			}
			break;

		case IDC_OPEN_PROJ:	// Save a project.
			proj_open(This);
			break;

		case IDC_SAVE_PROJ:	// Open a project.
			proj_save(This);
			break;

		case IDC_COLORS:
#ifdef FULL_VERSION
			DialogBoxParam(hInstance, (LPCTSTR) IDD_COLORS, This, ColorsDlgProc, NULL);
#else
			if (IDYES == MessageBox(This, MLS_MSG(LITE_MSG), MLS_MSG(TITLE1), MB_YESNO | MB_ICONQUESTION))
				ShellExecute(NULL, NULL, "http://mrhx.narod.ru/", NULL, NULL, 0);
#endif
			break;

		case IDC_INFO:
			DialogBoxParam(hInstance, (LPCTSTR) IDD_HELP, This, Help, NULL);
			break;

		case IDC_LANG:
			if (HIWORD(wParam) == CBN_SELENDOK)
			{
				if (SendDlgItemMessage(This, IDC_LANG, CB_GETCURSEL, 0, 0) == 1)
				{ // english.
					SetLang(LANG_EN, mls_main_en, sizeof(mls_main_en)/sizeof(mls_main_en[0]), This);
#ifndef DISABLE_BW
					bwSetHint(This, IDC_OK, "Create your installer!");
					bwSetHint(This, IDC_INFO, "Help on this program...");
					bwSetHint(This, IDCANCEL, "Close this program");
					bwSetHint(This, IDC_OPEN_PROJ, "Open project file...");
					bwSetHint(This, IDC_SAVE_PROJ, "Save current project...");
					bwSetHint(This, IDC_COLORS, "Change style of your installer...");
					bwSetHint(This, IDC_CHOOSE, "Choose a folder with your files...");
					bwSetHint(This, IDC_UNINST, "Create also an uninstaller (uninst.exe)");

					bwSetHint(This, IDC_CHECK_DESKTOP, "User controls a shortcut");
					bwSetHint(This, IDC_CHECK_STARTMENU, "User controls a shortcut");
					bwSetHint(This, IDC_CHECK_PROGRAMS, "User controls a shortcut");
					bwSetHint(This, IDC_CHECK_STARTUP, "User controls a shortcut");
					bwSetHint(This, IDC_CHECK_QUICKLAUNCH, "User controls a shortcut");
					bwSetHint(This, IDC_CHECK_SENDTO, "User controls a shortcut");
#endif
				}
				else
				{ // russian.
					SetLang(LANG_RU, mls_main_ru, sizeof(mls_main_ru)/sizeof(mls_main_ru[0]), This);

#ifndef DISABLE_BW
					bwSetHint(This, IDC_OK, "  !");
					bwSetHint(This, IDC_INFO, "  ...");
					bwSetHint(This, IDCANCEL, "  ");
					bwSetHint(This, IDC_OPEN_PROJ, "   ...");
					bwSetHint(This, IDC_SAVE_PROJ, "  ...");
					bwSetHint(This, IDC_COLORS, "   ...");
					bwSetHint(This, IDC_CHOOSE, "    ...");
					bwSetHint(This, IDC_UNINST, "   (uninst.exe)");

					bwSetHint(This, IDC_CHECK_DESKTOP, "  ");
					bwSetHint(This, IDC_CHECK_STARTMENU, "  ");
					bwSetHint(This, IDC_CHECK_PROGRAMS, "  ");
					bwSetHint(This, IDC_CHECK_STARTUP, "  ");
					bwSetHint(This, IDC_CHECK_QUICKLAUNCH, "  ");
					bwSetHint(This, IDC_CHECK_SENDTO, "  ");
#endif
				}
			}
			break;
		}
		break;

	case WM_SIZE:
	case WM_VSCROLL:
	case WM_HSCROLL:
		bwScrollWindowSupport(This, Msg, wParam, lParam, &WinSize);
		break;

	case WM_INITDIALOG:
		GetClientRect(This, &WinSize);
		bwCheckMaxWindowSize(This);

		SendMessage(This, WM_SETICON, ICON_SMALL, (LPARAM) LoadIcon(hInstance, (LPCTSTR) IDI_MAIN));
		SendMessage(This, WM_SETICON, ICON_BIG, (LPARAM) LoadIcon(hInstance, (LPCTSTR) IDI_MAIN));
		hProgress = GetDlgItem(This, IDC_PROGRESS);
#ifndef DISABLE_BW
		SendMessage(hProgress, PBM_SETBKCOLOR,  0, bwCurrentStyle.WindowBack);
		SendMessage(hProgress, PBM_SETBARCOLOR, 0, bwCurrentStyle.GroupBorder);
#endif
		SendMessage(hProgress, PBM_SETSTEP, 1, 0);
		SetDlgItemText(This, IDC_DEFAULT_INSTALL_PATH, "%ProgramFiles%");

#ifndef DISABLE_BW
		bwSetHintDisplayControl(This, IDC_HINTDEST, "(C) 2005-2007, Alexander G. Karpov a.k.a. mrhx");
		bwSetHint(This, IDC_OK, "  !");
		bwSetHint(This, IDC_INFO, "  ...");
		bwSetHint(This, IDCANCEL, "  ");
		bwSetHint(This, IDC_OPEN_PROJ, "   ...");
		bwSetHint(This, IDC_SAVE_PROJ, "  ...");
		bwSetHint(This, IDC_COLORS, "   ...");
		bwSetHint(This, IDC_CHOOSE, "    ...");
		bwSetHint(This, IDC_UNINST, "   (uninst.exe)");

		bwSetHint(This, IDC_CHECK_DESKTOP, "  ");
		bwSetHint(This, IDC_CHECK_STARTMENU, "  ");
		bwSetHint(This, IDC_CHECK_PROGRAMS, "  ");
		bwSetHint(This, IDC_CHECK_STARTUP, "  ");
		bwSetHint(This, IDC_CHECK_QUICKLAUNCH, "  ");
		bwSetHint(This, IDC_CHECK_SENDTO, "  ");
#endif

		SendDlgItemMessage(This, IDC_LANG, CB_ADDSTRING, 0, (LPARAM) "Russian ()");
		SendDlgItemMessage(This, IDC_LANG, CB_ADDSTRING, 0, (LPARAM) "English");
		SendDlgItemMessage(This, IDC_LANG, CB_SETCURSEL, 0, 0);

		SetLang(LANG_RU, mls_main_ru, sizeof(mls_main_ru)/sizeof(mls_main_ru[0]), This);
#ifndef DISABLE_BW
		//bwInstallWithEffect(This, bwEffect_RollOut_Center);
		bwInstall(This);
#endif
		return TRUE;

	}
	return FALSE;
}

//-----------------------------------------------------------------------------
// END OF FILE.
//-----------------------------------------------------------------------------
