//-----------------------------------------------------------------------------
// M-INSTALLER: VERSION 3.7
//
// (C) 2005-2007, Alexander G. Karpov a.k.a. mrhx.
//
//-----------------------------------------------------------------------------

//#define DISABLE_BW
#define FULL_VERSION

#define DO_NOT_INCLUDE_STD
#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include "resource.h"
//#ifndef DISABLE_BW
  #include "../bw.h"
  #include "../bw.cpp"
//#endif
#include "../sixpack.c"

//-----------------------------------------------------------------------------
// LINK&COMPILE OPTIONS.
//-----------------------------------------------------------------------------

#pragma comment(linker,"/NODEFAULTLIB")
#pragma comment(linker,"/ENTRY:main")
#pragma comment(linker,"/FILEALIGN:512")
//#pragma comment(linker,"/MERGE:.data=.text")
//#pragma comment(linker,"/MERGE:.rdata=.text")
//#pragma comment(linker,"/SECTION:.text,ERWX")
//#pragma comment(linker,"/IGNORE:4078")

//-----------------------------------------------------------------------------
// DEFINES.
//-----------------------------------------------------------------------------

#define TITLE		current_mls[MLS_TITLE]
#ifdef FULL_VERSION
#define THISSIZE	(13*1024+512)		// 13.5 KB (AFTER UPX) FULL
#else
#define THISSIZE	(12*1024)		// 12 KB (AFTER UPX) LITE
#endif
#define VERSION_NUM	"3.7"
//#ifdef FULL_VERSION
//#define VERSION		VERSION_NUM##" Full"
//#else
//#define VERSION		VERSION_NUM##" Lite"
//#endif


//-----------------------------------------------------------------------------
// TAGS FOR SETUP DATA:
//-----------------------------------------------------------------------------

#define TAG_SIGNATURE			'XHRM'
#define TAG_DIR					1
#define TAG_FILE				3
#define TAG_DIR_END				9
#define TAG_END					63

/*
	SETUP DATA FORMAT:
		
		SIGNATURE
		FLAGS				<-- in 2.0
		USER-STYLE			<-- in 2.0 if FLAG_STYLE_USER
		----
		MESSAGES			<-- in 2.7 - multilingual support.
					(EN)
					(RU)	<-- 3.0 - may be two lang's. if FLAG_ILANG_TWO
		----
		PASSWORD			<-- 3.0, if FLAG_PASSWORD
		MENU FOLDER NAME	<-- 3.0, if FLAG_MENU_FOLDER.
		----
		LICENSE
		UNINST_CODE			<-- v2.5, if FLAG_UNINST.
		LINKS-DESKTOP
		LINKS-PROGRAMS
		LINKS-QUICK_LAUNCH
		LINKS-SENDTO
		LINKS-STARTUP
		LINKS-START_MENU
		DEFAULT-INSTALL-PATH
		EXECUTE-LINE
		INSTALL-SIZE
		COUNT_OF_OBJECTS
		OBJECTS


	NEW IN V. 1.4:
	1)	EXTENDED FORMAT OF LINK TEXT:
			FILE_NAME/LINK_FILE_NAME/LINK_DESCRIPTION

		OLD FORMAT:
			FILE_NAME

	2)	EXECUTE-LINE:
			LIST OF ITEMS TO RUN AFTER INSTALLING.

	3)	DEFAULT INSTALL PATH:
			IT WAS PROGRAM_FILES BEFORE.

	4)	INSTALL-SIZE
			Approximate size of all installation files.

	5)	OPEN & SAVE PROJECT.


	NEW IN v1.5:
	1) More licenses available, but as *.mip projects.
	2) Ask for overwrite existent files while installing.
	3) Ask for agreement with license while installing.
	4) Show size of files in bytes or Kbytes or Mbytes (not only in Kbytes).
	5) Show free size on specified disk.

	NEW IN 2.0:

	1) separated installing module.
	2) user-defined styles.
	3) better GUI.

*/

//-----------------------------------------------------------------------------
// MESSAGES
//-----------------------------------------------------------------------------

enum mls_e
{
	MLS_TITLE,
	MLS_OUT_OF_ORDER,
	MLS_DIR,
	MLS_LINK_FAIL,
	MLS_ABOUT_MI,
	MLS_NA,
	MLS_SETUP_TITLE,
	MLS_DONE,
	MLS_DONE_TITLE,
	MLS_NOT_AGREE,
	MLS_CHOOSE_DIR,
	MLS_SIGNATURE,
	MLS_MEM,
	MLS_FILE_READ,
	MLS_FILE_PTR,
	MLS_ERR_CD,
	MLS_FILE_OPEN,
	MLS_ERR_UNPACK_LICENSE,
	MLS_REG_ERR,
	MLS_UNINST_DAT,
	MLS_NEW_DIR_ERR,
	MLS_CANT_NEW_UNINST_DAT,
	MLS_BAD_UNPACK,
	MLS_CANT_NEW_FILE,
	MLS_CANT_WRITE_FILE,
	MLS_BAD_CODE,
	MLS_NO_COM,
	MLS_B,
	MLS_KB,
	MLS_MB,
	MLS_GB,
	MLS_ABOUT_INFO,

	// gui:
	// main:
	MLS_STATIC2,
	MLS_AGREE,
	MLS_STATIC3,
	MLS_STATIC1,
	MLS_STATIC4,
	MLS_CANCEL,
	MLS_LINKS,
	MLS_OK,

	// replace file:
	MLS_REPLACE_TITLE,
	MLS_R_STATIC1,
	MLS_R_STATIC2,
	MLS_R_STATIC3,
	MLS_R_OK,
	MLS_R_CANCEL,
	MLS_R_YES,
	MLS_R_NO,

	// links:
	MLS_LINKS_TITLE,
	MLS_L_STATIC1,
	MLS_L_STATIC2,
	MLS_L_CANCEL,
	MLS_L_USE,
	MLS_L_DESKTOP,
	MLS_L_START,
	MLS_L_PROGRAMS,
	MLS_L_AUTORUN,
	MLS_L_QUICK,
	MLS_L_SENDTO,

	// Password dialog:
	MLS_PASSWD_TITLE,
	MLS_P_OK,
	MLS_P_CANCEL,
	MLS_P_INFO,
	MLS_P_BAD,

	MLS_COUNT
};

char * mls_ru [MLS_COUNT] = 
{
	"mInstaller",
	"Warning",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"Could not read the file signature. The file is broken.",
	"Memory allocation error.",
	"Could not read: ",
	"File pointer error.",
	"",
	"Could not open: ",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"Bad setup data. The file is possibly broken.",
	"",
	"",
	"",
	"",
	"",
	"",

	// gui:
	// main:
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",

	// replace file:
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",

	// links:
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",

	// passwd:
	"",
	"",
	"",
	"",
	""
};

char **current_mls = mls_ru;

#define MLS(index_) current_mls[MLS_##index_]

int mls_main [] =
{
	MLS_SETUP_TITLE,

	IDC_STATIC2,	MLS_STATIC2,
	IDC_AGREE,		MLS_AGREE,
	IDC_STATIC3,	MLS_STATIC3,
	IDC_STATIC1,	MLS_STATIC1,
	IDC_STATIC4,	MLS_STATIC4,
	IDC_CANCEL,		MLS_CANCEL,
	IDC_LINKS,		MLS_LINKS,
	IDC_OK,			MLS_OK
};

int mls_links [] =
{
	MLS_LINKS_TITLE,

	IDC_STATIC1,			MLS_L_STATIC1,
	IDC_STATIC2,			MLS_L_STATIC2,
	IDCANCEL,				MLS_L_CANCEL,
	IDOK,					MLS_L_USE,
	IDC_LINK_DESKTOP,		MLS_L_DESKTOP,
	IDC_LINK_STARTMENU,		MLS_L_START,
	IDC_LINK_PROGRAMS,		MLS_L_PROGRAMS,
	IDC_LINK_STARTUP,		MLS_L_AUTORUN,
	IDC_LINK_QUICKLAUNCH,	MLS_L_QUICK,
	IDC_LINK_SENDTO,		MLS_L_SENDTO
};

int mls_replace [] =
{
	MLS_REPLACE_TITLE,

	IDC_STATIC1,	MLS_R_STATIC1,
	IDC_STATIC2,	MLS_R_STATIC2,
	IDC_STATIC3,	MLS_R_STATIC3,
	IDOK,			MLS_R_OK,
	IDCANCEL,		MLS_R_CANCEL,
	IDC_ALWAYS_YES,	MLS_R_YES,
	IDC_ALWAYS_NO,	MLS_R_NO
};

int mls_passwd [] =
{
	MLS_PASSWD_TITLE,

	IDOK,			MLS_P_OK,
	IDCANCEL,		MLS_P_CANCEL,
	IDC_STATIC_1,	MLS_L_STATIC1,
	IDC_STATIC_2,	MLS_P_INFO
};

void UseLang(int *ids, int num, HWND hwnd)
{
	SetWindowText(hwnd, current_mls[*ids]);
	for (int i = 1; i < num; i += 2)
		SetDlgItemText(hwnd, ids[i], current_mls[ids[i+1]]);
	RedrawWindow(hwnd, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW);
}

//-----------------------------------------------------------------------------
// PROTOTYPES.
//-----------------------------------------------------------------------------

void __fastcall _(int code, char *msg);
char * __fastcall GetMem(unsigned int size);
void _w(int code, char *msg, ...);
void CreateLink(LPCSTR lpszPathObj, LPSTR lpszPathLink, LPSTR lpszDesc, LPCTSTR WorkDir);
BOOL CALLBACK InstallDlg(HWND This, UINT Msg, WPARAM wParam, LPARAM lParam);
int IsThisInstaller();
int parse_link_descr(const char *text, const char *file, char *link_name, char *link_descr);
int RunReplaceFileDialog(HWND Parent, char *filename, DWORD newsize);
int OpenThisInstaller();

char ThisFile [MAX_PATH];
HWND hProgress;

#define FLAG_STYLE_WINDOWS			0x01	// If gui will have default windows style.
#define FLAG_EFFECT_UPDOWN			0x02
#define FLAG_EFFECT_LEFTRIGHT		0x04
#define FLAG_EFFECT_CENTER			0x08
#define FLAG_STYLE_USER				0x10

#define FLAG_UNINST					0x00001000	// Need uninstaller.

#define FLAG_CHECK_DESKTOP			0x00010000
#define FLAG_CHECK_STARTMENU		0x00020000
#define FLAG_CHECK_PROGRAMS			0x00040000
#define FLAG_CHECK_STARTUP			0x00080000
#define FLAG_CHECK_QUICKLAUNCH		0x00100000
#define FLAG_CHECK_SENDTO			0x00200000

#define FLAG_ILANG_TWO				0x10000000	// If two installer languages available and need to choose one.
#define FLAG_PASSWORD				0x20000000	// if password needed.
#define FLAG_MENU_FOLDER			0x40000000	// if menu folder exists.


#ifndef DISABLE_BW
bwStyleStruct UserStyle;
#endif
DWORD Flags = 0;
DWORD CurrentFlags = 0;
char ProgName [128];
char *MenuFolderName = NULL;
int current_ilang = 0;

//-----------------------------------------------------------------------------
// MAIN FUNCTION.
//-----------------------------------------------------------------------------

HINSTANCE hInstance = NULL;

void main()
{
	InitCommonControls();
	GetModuleFileName(NULL, ThisFile, MAX_PATH-1);
	hInstance = GetModuleHandle(NULL);
#ifndef DISABLE_BW
	bwInit();
	memcpy(&UserStyle, &bwCurrentStyle, sizeof(bwStyleStruct));
#endif
	if (!OpenThisInstaller())
	{
		MessageBox(NULL, MLS(SIGNATURE), TITLE, MB_OK|MB_TOPMOST|MB_ICONERROR);
	}
	else
	{
		DialogBoxParam(hInstance, (LPCTSTR) IDD_INSTALL, NULL, InstallDlg, NULL);
	}
	ExitProcess(0);
}

typedef unsigned char UBYTE;

//-----------------------------------------------------------------------------
// MEMORY ALLOCATION.
//-----------------------------------------------------------------------------

char * __fastcall GetMem(unsigned int size)
{
	void * ptr = LocalAlloc(LMEM_FIXED, size);
	_(!ptr, MLS(MEM));
	return (char *) ptr;
}

//-----------------------------------------------------------------------------
// ERROR PROCESSING.
//-----------------------------------------------------------------------------

void __fastcall _(int code, char *msg)
{
	if (code)
	{
		MessageBox(NULL, msg, TITLE, MB_ICONERROR | MB_TOPMOST);
		ExitProcess(1);
	}
}

void __fastcall _(int code, char *msg, char *msg1)
{
	if (code)
	{
		char tmp [512];
		_(code, lstrcat(lstrcpy(tmp, msg), msg1));
	}
}


void _w(int code, char *msg, ...)
{
	if (code)
	{
		char mesg [512];
		wvsprintf(mesg, msg, (va_list)(&msg+1));
		MessageBox(NULL, mesg, MLS(OUT_OF_ORDER), MB_OK|MB_TOPMOST|MB_ICONWARNING);
	}
}

//-----------------------------------------------------------------------------
// GET WINDOW TEXT:
//-----------------------------------------------------------------------------

char * __fastcall get_text(HWND hWnd)
{
	int size = GetWindowTextLength(hWnd) + 1;
	char * text = GetMem(size);
	GetWindowText(hWnd, text, size);
	return text;
}

//-----------------------------------------------------------------------------
// FILE HANDLE FOR TARGET SETUP PROGRAM.
//-----------------------------------------------------------------------------

HANDLE hSetup;

//-----------------------------------------------------------------------------
// ACTIONS WITH SETUP FILE:
//-----------------------------------------------------------------------------

void ShowErr()
{
	LPVOID lpMsgBuf;
 
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL);

	// Display the string.
	MessageBox( NULL, (char*)lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

	// Free the buffer.
	LocalFree( lpMsgBuf );
}

void crypt(UBYTE *data, ULONG len) // En/De-crypt data.
{
	register UBYTE *p = data;
	register ULONG n = len;
	for (; n; --n, ++p) *p ^= (UBYTE)(n & 0xFF);
}

void __fastcall read_data(void *ptr, unsigned int size)
{
	DWORD d;
	if (!ReadFile(hSetup, ptr, size, &d, NULL))
	{
		ShowErr();
		_(1, MLS(FILE_READ), ThisFile);
	}
	crypt((UBYTE*) ptr, size);
}

char __fastcall read_char_data()
{
	char ch;
	read_data(&ch, 1);
	return ch;
}

void set_data_pos(LONG Move, DWORD Method)
{
	_(0xFFFFFFFF == SetFilePointer(hSetup, Move, NULL, Method), MLS(FILE_PTR));
}

//-----------------------------------------------------------------------------
// CHANGE DIR:
//-----------------------------------------------------------------------------
void __fastcall cd(const char *dir)
{
	_w(!SetCurrentDirectory(dir), MLS(ERR_CD), dir);
}

//-----------------------------------------------------------------------------
// FUNCTION TO CHOOSE DIRECTORY.
//-----------------------------------------------------------------------------
#ifndef DISABLE_BW
int CALLBACK BrowseCallbackProc(HWND This, UINT Msg, LPARAM lParam, LPARAM Data)
{
	if (Msg == BFFM_INITIALIZED)
	{
		if (!(Flags & FLAG_STYLE_WINDOWS)) bwInstall(This, &UserStyle);
	}
	return 0;
}
#endif
BOOL ChooseFolder(HWND hOwner, LPTSTR pszPath, LPCTSTR Caption)
{
	BROWSEINFO bi;
	LPITEMIDLIST pidl;
	LPMALLOC pMalloc;
	BOOL Res = FALSE;

	if (SUCCEEDED(SHGetMalloc(&pMalloc)))
	{
		bi.hwndOwner		= hOwner;
		bi.pidlRoot			= NULL;
		bi.pszDisplayName	= pszPath;
		bi.lpszTitle		= Caption;
		bi.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_EDITBOX;
#ifndef DISABLE_BW
		bi.lpfn				= BrowseCallbackProc;
#else
		bi.lpfn				= NULL;
#endif

		if (pidl = SHBrowseForFolder(&bi))
		{
			Res = SHGetPathFromIDList(pidl, pszPath);
			pMalloc->Free(pidl);
		}
		pMalloc->Release();
	}
	return Res;
}

//=============================================================================
//=============================================================================
//
// INSTALLING CODE:
//
//=============================================================================
//=============================================================================

//-----------------------------------------------------------------------------
// OPEN THIS INSTALLING MODULE.
//-----------------------------------------------------------------------------

int OpenThisInstaller()
{
	hSetup = CreateFile(ThisFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, NULL);
	_(INVALID_HANDLE_VALUE == hSetup, MLS(FILE_OPEN), ThisFile);
	set_data_pos(THISSIZE, FILE_BEGIN);
	int sign = 0;
	read_data(&sign, 4);
	int ret = (sign == TAG_SIGNATURE);
	if (!ret) CloseHandle(hSetup);
	return ret;
}

//-----------------------------------------------------------------------------
// READ LICENSE
//-----------------------------------------------------------------------------

char * ReadLicense()
{
	ULONG len, compressed;
	read_data(&len, 4);				// READ LICENSE LENGTH.
	read_data(&compressed, 4);		// READ COMPRESSED LENGTH.
	char * license = GetMem(len+1);
	char * comp = GetMem(compressed);
	read_data(comp, compressed);

	if (len == compressed)
	{
		memcpy(license, comp, len);
		bytes_out = len;
	}
	else
	{
		STREAM s_in, s_out;
		stream_init_mem(&s_in, (unsigned char *) comp, compressed, STREAM_READ);
		stream_init_mem(&s_out, (unsigned char *) license, len, STREAM_WRITE);
		decode(&s_in, &s_out);
	}

	_w((int)len != bytes_out, MLS(ERR_UNPACK_LICENSE));

	license [len] = 0;
	LocalFree(comp);
	return license;
}

//-----------------------------------------------------------------------------
// READ DESKTOP LINKS:
//-----------------------------------------------------------------------------

char *DesktopLinks = "",
	 *ProgramsLinks = "",
	 *QuickLaunchLinks = "",
	 *SendToLinks = "",
	 *StartUpLinks = "",
	 *StartMenuLinks = "";

char DesktopPath [MAX_PATH],
	 ProgramsPath [MAX_PATH],
	 QuickLaunchPath [MAX_PATH],
	 SendToPath [MAX_PATH],
	 StartUpPath [MAX_PATH],
	 StartMenuPath [MAX_PATH];

char * RunAfterInstall = "";


// uninstaller support:
unsigned char *uninst_code;
unsigned int uninst_length;


char * ReadStr(char pre_last_char = 0)
{
	unsigned int len;
	read_data(&len, 4);
	register char *p = GetMem(len+2);
	read_data(p, len);
	p [len] = pre_last_char;
	p [len+1] = 0;
	return p;
}

void ReadLinks(char **pLinks, char *Path, char *RegKey)
{
	*pLinks = ReadStr(',');
	// Get Desktop Path:
	HKEY hKey;
	DWORD tmp = MAX_PATH;
	DWORD tmp1 = REG_SZ;
	*Path = 0;
	if (ERROR_SUCCESS != RegOpenKeyEx(HKEY_CURRENT_USER,
		"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",
		0, KEY_READ, &hKey)) _w(TRUE, MLS(REG_ERR));
	else 
	{
		_w(ERROR_SUCCESS != RegQueryValueEx(hKey, RegKey, NULL, &tmp1, (LPBYTE) Path, &tmp), MLS(REG_ERR));
		RegCloseKey(hKey);
	}
}

void write_uninst_dat_line(char *pref, char *line);

void CreateLinkOnPath(char *Links, char *Path, char * name)
{
	char link_name [MAX_PATH], link_descr [MAX_PATH];

	if (parse_link_descr(Links, name, link_name, link_descr))
	{
		char link [MAX_PATH], obj [MAX_PATH], WorkDir [MAX_PATH];
		lstrcat(lstrcat(lstrcat(lstrcpy(link, Path), "\\"), link_name), ".lnk");
		GetCurrentDirectory(MAX_PATH, WorkDir);
		lstrcat(lstrcat(lstrcpy(obj, WorkDir), "\\"), name);
		CreateLink(obj, link, link_descr, WorkDir);
		write_uninst_dat_line("#", link); // remove link when uninstalling.
	}
}

//-----------------------------------------------------------------------------
// INSTALL:
//-----------------------------------------------------------------------------

int needlink(int flg)
{
	return !((Flags & flg) && !(CurrentFlags & flg));
}

void check_for_links(char *dir)
{
	if (needlink(FLAG_CHECK_DESKTOP)) CreateLinkOnPath(DesktopLinks, DesktopPath, dir);
	if (needlink(FLAG_CHECK_PROGRAMS)) CreateLinkOnPath(ProgramsLinks, ProgramsPath, dir);
	if (needlink(FLAG_CHECK_QUICKLAUNCH)) CreateLinkOnPath(QuickLaunchLinks, QuickLaunchPath, dir);
	if (needlink(FLAG_CHECK_SENDTO)) CreateLinkOnPath(SendToLinks, SendToPath, dir);
	if (needlink(FLAG_CHECK_STARTUP)) CreateLinkOnPath(StartUpLinks, StartUpPath, dir);
	if (needlink(FLAG_CHECK_STARTMENU)) CreateLinkOnPath(StartMenuLinks, StartMenuPath, dir);
}

int ProgramDir = 0;
HANDLE hUninstDatFile;

void write_uninst_dat(char *str)
{
	if ((Flags & FLAG_UNINST) && hUninstDatFile != INVALID_HANDLE_VALUE)
	{
		DWORD d;
		_w(!WriteFile(hUninstDatFile, str, lstrlen(str), &d, NULL), MLS(UNINST_DAT));
	}
}

void write_uninst_dat_line(char *pref, char *line)
{
	write_uninst_dat(pref);
	write_uninst_dat(line);
	write_uninst_dat("\r\n");
}

#define FILE_PREFIX_NULL	0
#define FILE_PREFIX_STORE	1

void Inst(HWND This)
{
INST_START:

	SendMessage(hProgress, PBM_STEPIT, 0, 0);

	char tag = read_char_data();

	if (tag == TAG_DIR)
	{
		// INSTALL DIRECTORY:
		char dir [MAX_PATH];
		int len;

		read_data(&len, 4);		// READ NAME LENGTH.
		read_data(dir, len);	// READ DIRECTORY NAME.
		dir [len] = 0;

		_w((0xFFFFFFFF == GetFileAttributes(dir) && !CreateDirectory(dir, NULL)), MLS(NEW_DIR_ERR), dir);

		if (!ProgramDir && (Flags & FLAG_UNINST))
		{
			cd(dir);
			hUninstDatFile = CreateFile("uninst.dat", GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
			cd("..");
			_w(hUninstDatFile == INVALID_HANDLE_VALUE, MLS(CANT_NEW_UNINST_DAT), "uninst.dat");
			write_uninst_dat_line(ProgName, "");
		}

		// Check for links:
		check_for_links(dir);

		cd(dir);
		if (ProgramDir) write_uninst_dat_line("@", dir);

		++ProgramDir;

		Inst(This);

		if (--ProgramDir)
		{
			cd("..");
			write_uninst_dat_line("@", "..");
			write_uninst_dat_line("%", dir);
		}

		// TAG_END_DIR
	}
	else if (tag == TAG_FILE)
	{
		// INSTALL FILE:
		int len;
		ULONG size, size_compressed, size1;
		char * buf, *content;
		char name [MAX_PATH];
		HANDLE hFile;
		DWORD d;
		unsigned char file_prefix = read_char_data(); // read file prefix with varied flags.

		STREAM s_in, s_out;

		read_data(&len, 4);		// READ FILE NAME LENGTH.
		read_data(name, len);	// READ FILE NAME.
		name [len] = 0;

		read_data(&size, 4);				// READ FILE DATA SIZE.
		if (file_prefix & FILE_PREFIX_STORE)
			size_compressed = size;
		else read_data(&size_compressed, 4);		// READ COMPRESSED DATA SIZE.

		buf = GetMem(size_compressed);		// GET MEMORY FOR FILE CONTENT.
		read_data(buf, size_compressed);

		content = GetMem(size);

		if (file_prefix & FILE_PREFIX_STORE)
		{
			memcpy(content, buf, size);
			size1 = size;
		}
		else
		{
			stream_init_mem(&s_in, (unsigned char *) buf, size_compressed, STREAM_READ);
			stream_init_mem(&s_out, (unsigned char *) content, size, STREAM_WRITE);
			decode(&s_in, &s_out);

			size1 = bytes_out;
		}

		_w(size != size1, MLS(BAD_UNPACK), name);

		LocalFree(buf);

		if (GetFileAttributes(name) != 0xFFFFFFFF && 
			!RunReplaceFileDialog(This, name, size)) goto skip_createfile;

		hFile = CreateFile(name, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE) _w(TRUE, MLS(CANT_NEW_FILE), name);
		else
		{
			_w(!WriteFile(hFile, content, size, &d, NULL), MLS(CANT_WRITE_FILE), name);
			CloseHandle(hFile);
		}

skip_createfile:

		LocalFree(content);

		// Check for links:
		check_for_links(name);
		write_uninst_dat_line("#", name);

	}
	else if (tag == TAG_DIR_END) return;
	else if (tag == TAG_END)
	{
		if (!(Flags & FLAG_UNINST)) return;

		HANDLE hFile;
		char *name = "uninst.exe";
		DWORD d;

		if (GetFileAttributes(name) != 0xFFFFFFFF &&
			!RunReplaceFileDialog(This, name, uninst_length)) goto skip_createfile_uninst;

		hFile = CreateFile(name, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE) _w(TRUE, MLS(CANT_NEW_UNINST_DAT), name);
		else
		{
			_w(!WriteFile(hFile, uninst_code, uninst_length, &d, NULL), MLS(CANT_WRITE_FILE), name);
			CloseHandle(hFile);
		}

skip_createfile_uninst:

		check_for_links(name);
		return;
	}
	else _w(TRUE, MLS(BAD_CODE));

	goto INST_START;
}

DWORD WINAPI DoInstallThread(LPVOID p)
{
	HWND This = (HWND) p;
	char * dir = get_text(GetDlgItem(This, IDC_DIR));

	if (GetFileAttributes(dir) == 0xFFFFFFFF)
	{
		if (!CreateDirectory(dir, NULL))
		{
			MessageBox(This, MLS(DIR), TITLE, MB_ICONWARNING|MB_OK|MB_TOPMOST);
			return 0;
		}
	}

	EnableWindow(GetDlgItem(This, IDC_OK), FALSE);
	ShowWindow(hProgress, SW_SHOW);

	cd(dir);

	_w(!SUCCEEDED(CoInitialize(NULL)), MLS(NO_COM));

	Inst(This);

	CoUninitialize();

	// delete program folder in programs menu:
	if (MenuFolderName)
	{
		write_uninst_dat_line("%", ProgramsPath);
//		write_uninst_dat_line("@", "..");
//		write_uninst_dat_line("%", MenuFolderName);
	}

	CloseHandle(hUninstDatFile);
	LocalFree(dir);

	PostMessage(This, WM_USER+23, 0, 0);

	// RUN SPECIFIED FILES:
	char file [MAX_PATH];
	char *r = RunAfterInstall;
	int i;
	unsigned int ret;
	if (*r == 0) goto end_files;
next_file:
	while (*r == ' ') ++r; // skip spaces;
	i = 0;
	for (; *r && *r != ','; ++r, ++i) file [i] = *r;
	if (*r) ++r;
	file [i] = 0;
	ret = (unsigned int) ShellExecute(NULL, NULL, file, NULL, NULL, SW_SHOWNORMAL);

	if (*r) goto next_file;
end_files:
	
	return 0;
}

//-----------------------------------------------------------------------------
// Convert size, in bytes, to string.
//-----------------------------------------------------------------------------
void convert_size_to_string(char *str, unsigned long size)
{
	if (size < 1024) // bytes
	{
		wsprintf(str, MLS(B), size);
	}
	else if (size < 1024*1024) // Kbytes
	{
		wsprintf(str, MLS(KB), size/1024, ((size%1024)*10)/1024);
	}
	else // Mbytes
	{
		wsprintf(str, MLS(MB), size/(1024*1024), ((size%(1024*1024))*10)/(1024*1024));
	}
}

void convert_size_to_string(char *str, unsigned long b_s, unsigned long s_c, unsigned long c_d)
// b_s - bytes in a sector.
// s_c - sectors in cluster.
// c_d - free clusters in disk.
{
	unsigned long n = (b_s * s_c) / 1024;
	unsigned long size = c_d * n;

	if (size < 1024) // Kbytes
	{
		wsprintf(str, MLS(KB), size);
	}
	else if (size < 1024*1024) // Mbytes
	{
		wsprintf(str, MLS(MB), size/1024, ((size%1024)*10)/1024);
	}
	else // Gbytes
	{
		wsprintf(str, MLS(GB), size/(1024*1024), ((size%(1024*1024))*10)/(1024*1024));
	}
}


void read_messages()
{
	int ii;
	for (ii = 0; ii < MLS_COUNT; ++ii)
	{
		mls_ru [ii] = ReadStr();
	}
}


void skip_messages()
{
	int ii;
	for (ii = 0; ii < MLS_COUNT; ++ii)
	{
		LocalFree(ReadStr());
	}
}

/*
	SETUP DATA FORMAT:
		
		SIGNATURE
		LICENSE
		LINKS-DESKTOP
		LINKS-PROGRAMS
		LINKS-QUICK_LAUNCH
		LINKS-SENDTO
		LINKS-STARTUP
		LINKS-START_MENU
		DEFAULT-INSTALL-PATH
		EXECUTE-LINE
		INSTALL-SIZE
		COUNT_OF_OBJECTS
		OBJECTS
		
*/

#include "dlg.h"

static int allidshide[12] = 
{ IDC_STATIC2, IDC_STATIC3, IDC_STATIC4, IDC_LICENSE, IDC_PROGRESS, IDC_AGREE,
  IDC_DIR, IDC_CHOOSE, IDC_OK, IDC_SIZE_OF_FILES, IDC_FREE_DISK_SIZE, IDC_LINKS
};


//-----------------------------------------------------------------------------
// INSTALL DLG PROCEDURE:
//-----------------------------------------------------------------------------
RECT WinSize;

BOOL CALLBACK InstallDlg(HWND This, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg)
	{
	case WM_COMMAND:
	case WM_SYSCOMMAND:
		switch (LOWORD(wParam))
		{
		//-----------------------------------------------------------------------------
		// CHOOSE DIRECTORY WITH SOURCE FILES:
		//-----------------------------------------------------------------------------
		case IDC_CHOOSE:
			{
				char dir [MAX_PATH];

				if (ChooseFolder(This, dir, MLS(CHOOSE_DIR)))
				{
					DWORD d0, d1, d2, d3;

					SetDlgItemText(This, IDC_DIR, dir);
					dir[2] = '\0'; // truncate path. leave only disk name.

					if (GetDiskFreeSpace(dir, &d0, &d1, &d2, &d3))
					{
						convert_size_to_string(dir, d0, d1, d2);
					}
					else lstrcpy(dir, MLS(NA));
					SetDlgItemText(This, IDC_FREE_DISK_SIZE, dir);
				}
			}
			break;

		case IDC_DIR:
			if (HIWORD(wParam) == EN_CHANGE)
			{
				DWORD d0, d1, d2, d3;
				char dir [MAX_PATH];

				GetDlgItemText(This, IDC_DIR, dir, MAX_PATH);
				dir[2] = '\0'; // truncate path. leave only disk name.

				if (GetDiskFreeSpace(dir, &d0, &d1, &d2, &d3))
				{
					convert_size_to_string(dir, d0, d1, d2);
				}
				else lstrcpy(dir, MLS(NA));
				SetDlgItemText(This, IDC_FREE_DISK_SIZE, dir);
			}
			break;

		case IDC_INFO:
			MessageBox(This, MLS(ABOUT_INFO), TITLE, MB_ICONINFORMATION);
			break;

		case IDC_OK:		// INSTALL!
			if (BST_CHECKED == IsDlgButtonChecked(This, IDC_AGREE))
			{
				DWORD th_id;

				if (!CreateThread(NULL, 0, DoInstallThread, (LPVOID) This, 0, &th_id))
				{
					DoInstallThread((LPVOID) This);
				}
			}
			else MessageBox(This, MLS(NOT_AGREE), TITLE, MB_ICONINFORMATION);
			break;

		case IDC_CANCEL:
		case SC_CLOSE:
			EndDialog(This, 0);
			break;

		case IDC_LINKS:
			DialogBoxParam(hInstance, (LPCTSTR) IDD_LINKS, This, LinksDlg, NULL);
			break;
		}
		break;

	case WM_SIZE:
	case WM_VSCROLL:
	case WM_HSCROLL:
		bwScrollWindowSupport(This, Msg, wParam, lParam, &WinSize);
		break;

	case WM_USER+23: // install done.
		SetWindowText(This, MLS(DONE_TITLE));
		{
			for (int i = 0; i < 12; ++i) ShowWindow(GetDlgItem(This, allidshide[i]), SW_HIDE);
			HWND hwnd = GetDlgItem(This, IDC_STATIC1);
			SetWindowPos(hwnd, HWND_TOP, 8, WinSize.bottom/4, WinSize.right-16, WinSize.bottom/2, 0);
			SetWindowLong(hwnd, GWL_STYLE, SS_CENTER | GetWindowLong(hwnd, GWL_STYLE));
			SetWindowText(hwnd, MLS(DONE));
			hwnd = GetDlgItem(This, IDC_CANCEL);
			RECT rc;
			GetWindowRect(hwnd, &rc);
			MapWindowPoints(NULL, This, (LPPOINT) &rc, 2);
			SetWindowPos(hwnd, HWND_TOP, (WinSize.right-rc.right+rc.left)/2, rc.top,
				rc.right-rc.left, rc.bottom-rc.top, 0);
		}
		break;

	case WM_INITDIALOG:
		GetClientRect(This, &WinSize);
		bwCheckMaxWindowSize(This);

		SendMessage(This, WM_SETICON, ICON_SMALL, (LPARAM) LoadIcon(hInstance, (LPCTSTR) IDI_MAIN));
		SendMessage(This, WM_SETICON, ICON_BIG, (LPARAM) LoadIcon(hInstance, (LPCTSTR) IDI_MAIN));
		read_data(&Flags, 4);
		CurrentFlags = Flags;
		// read style:
#ifndef DISABLE_BW
		if (Flags & FLAG_STYLE_USER) read_data(&UserStyle, sizeof(bwStyleStruct));
#endif
		// check whether there is only language or two ?
		if (Flags & FLAG_ILANG_TWO)
		{
			current_ilang = (IDC_ILANG_RU == DialogBoxParam(hInstance, (LPCTSTR) IDD_ILANG, NULL, ChooseILang, NULL));

			if (current_ilang)
			{
				skip_messages();
				read_messages();
			}
			else // en (default)
			{
				read_messages();
				skip_messages();
			}
		}
		else read_messages();

		// Check for password:
		if (Flags & FLAG_PASSWORD)
		{
			char *passwd = ReadStr();
			int passwd_ret = DialogBoxParam(hInstance, (LPCTSTR) IDD_PASSWD, NULL, PasswdDlg, (LPARAM) passwd);
			LocalFree(passwd);
			if (passwd_ret == 0)
			{
				MessageBox(NULL, MLS(P_BAD), TITLE, MB_OK|MB_ICONWARNING);
				EndDialog(This, 0);
				return TRUE;
			}
		}

		// check for menu folder:
		if (Flags & FLAG_MENU_FOLDER)
		{
			MenuFolderName = ReadStr();
		}
		else MenuFolderName = NULL;

		UseLang(mls_main, sizeof(mls_main)/sizeof(mls_main[0]), This);

		// READ LICENSE:
		{
			char * license = ReadLicense();
			SetDlgItemText(This, IDC_LICENSE, license);
			LocalFree(license);
		}
		// Read program name:
		{
			int prognamelen = 0;
			read_data(&prognamelen, 4);
			read_data(ProgName, prognamelen);
			ProgName [prognamelen] = '\0';
			char Title[256];
			lstrcat(lstrcpy(Title, MLS(SETUP_TITLE)), ProgName);
			SetWindowText(This, Title);
		}
		// Read producer name:
		{
			char *str = ReadStr();
			SetDlgItemText(This, IDC_PRODUCER, str);
			LocalFree(str);
		}
		// Read uninstalling code:
		if (Flags & FLAG_UNINST) 
		{
			read_data(&uninst_length, 4);
			uninst_code = (unsigned char *) GetMem(uninst_length);
			read_data(uninst_code, uninst_length);

			if (Flags & FLAG_ILANG_TWO)
			{
				if (current_ilang) // ru ?
				{
					LocalFree(uninst_code);
					read_data(&uninst_length, 4);
					uninst_code = (unsigned char *) GetMem(uninst_length);
					read_data(uninst_code, uninst_length);
				}
				else // en: skip ru uninstaller code.
				{
					LocalFree(ReadStr());
				}
			}
		}
		// READ LINKS:
		ReadLinks(&DesktopLinks, DesktopPath, "Desktop");
		ReadLinks(&ProgramsLinks, ProgramsPath, "Programs");
		// Need menu folder ?
		if (MenuFolderName && ProgramsLinks[0] && ProgramsLinks[1])
		{
			lstrcat(lstrcat(ProgramsPath, "\\"), MenuFolderName);
			CreateDirectory(ProgramsPath, NULL);
		}
		ReadLinks(&QuickLaunchLinks, QuickLaunchPath, "AppData");
		if (QuickLaunchPath [0]) lstrcat(QuickLaunchPath, "\\Microsoft\\Internet Explorer\\Quick Launch");
		ReadLinks(&SendToLinks, SendToPath, "SendTo");
		ReadLinks(&StartUpLinks, StartUpPath, "Startup");
		ReadLinks(&StartMenuLinks, StartMenuPath, "Start Menu");
		{
			char dir [MAX_PATH];

			// Read default install path:
			char *DefInstPath = ReadStr();

			// Read run-line:
			RunAfterInstall = ReadStr();

			unsigned int count, SizeOfFiles;
			read_data(&SizeOfFiles, 4);
			read_data(&count, 4);

			convert_size_to_string(dir, SizeOfFiles);
			SetDlgItemText(This, IDC_SIZE_OF_FILES, dir);

			DWORD d0, d1, d2, d3;

			hProgress = GetDlgItem(This, IDC_PROGRESS);
#ifndef DISABLE_BW
			if (!(Flags & FLAG_STYLE_WINDOWS))
			{
				SendMessage(hProgress, PBM_SETBKCOLOR,  0, UserStyle.WindowBack);
				SendMessage(hProgress, PBM_SETBARCOLOR, 0, UserStyle.GroupBorder);
			}
#endif
			SendMessage(hProgress, PBM_SETSTEP, 1, 0);
			SendMessage(hProgress, PBM_SETRANGE, 0, MAKELONG(0, count));

			// Set default install path:

			if (ExpandEnvironmentStrings(DefInstPath, dir, MAX_PATH))
				SetDlgItemText(This, IDC_DIR, dir);

			dir[2] = '\0'; // truncate path. leave only disk name.
			if (GetDiskFreeSpace(dir, &d0, &d1, &d2, &d3))
			{
				convert_size_to_string(dir, d0, d1, d2);
			}
			else lstrcpy(dir, MLS(NA));
			SetDlgItemText(This, IDC_FREE_DISK_SIZE, dir);
		}
#ifndef DISABLE_BW
		if (!(Flags & FLAG_STYLE_WINDOWS))
		{
			if (Flags & FLAG_EFFECT_UPDOWN) bwInstallWithEffect(This, &UserStyle, bwEffect_RollOut_UpDown);
			else if (Flags & FLAG_EFFECT_LEFTRIGHT) bwInstallWithEffect(This, &UserStyle, bwEffect_RollOut_LeftRight);
			else if (Flags & FLAG_EFFECT_CENTER) bwInstallWithEffect(This, &UserStyle, bwEffect_RollOut_Center);
			else bwInstall(This, &UserStyle);
		}
#endif
		{
			HMENU hMenu = GetSystemMenu(This, FALSE);
			AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
			AppendMenu(hMenu, MF_STRING, IDC_INFO, MLS(ABOUT_MI));
		}
		// Hide 'Links' button:
		if (!(Flags & (FLAG_CHECK_DESKTOP|FLAG_CHECK_STARTMENU|
			FLAG_CHECK_PROGRAMS|FLAG_CHECK_STARTUP|
			FLAG_CHECK_QUICKLAUNCH|FLAG_CHECK_SENDTO))) ShowWindow(GetDlgItem(This, IDC_LINKS), SW_HIDE);

		return TRUE;
	}
	return FALSE;
}

//-----------------------------------------------------------------------------
// PARSE LINK DESCRIPTION:
//-----------------------------------------------------------------------------

int parse_link_descr(const char *text, const char *file, char *link_name, char *link_descr)
{
	int file_ln = lstrlen(file);
	register const char *p = text;

	while (*p == ' ') ++p; // skip space(s).
	if (lstrlen(p) >= file_ln && !memcmp(p, file, file_ln) &&
		(p[file_ln] == ',' || p[file_ln] == '/'))
	{ // file descr found:
		p += file_ln; // goto '/' or ','
		if (*p == '/')
		{
			char *sv_lnk = link_name;
			for(++p; *p && *p != ',' && *p != '/'; ++p, ++link_name) *link_name = *p;
			*link_name = 0;
			if (*p == '/')
				for(++p; *p && *p != ','; ++p, ++link_descr) *link_descr = *p;
			else
				lstrcpy(link_descr, sv_lnk);
		}
		else
			lstrcpy(link_descr, lstrcpy(link_name, file));

		return 1;
	}

	while (*p && *p != ',') ++p; // skip unmatched name.

	if (*p) ++p; // skip possible ','.

	if (*p) return parse_link_descr(p, file, link_name, link_descr);
	return 0;
}

//-----------------------------------------------------------------------------
// FUNCTION TO CREATE SHELL LINKS:
//-----------------------------------------------------------------------------

void CreateLink(LPCSTR lpszPathObj, LPSTR lpszPathLink, LPSTR lpszDesc, LPCTSTR WorkDir)
{
	HRESULT hres;
    IShellLink* psl; 
 
    // Get a pointer to the IShellLink interface. 
    hres = CoCreateInstance(CLSID_ShellLink, NULL, 
        CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*) &psl); 
    if (SUCCEEDED(hres)) { 
        IPersistFile* ppf; 

        // Set the path to the shortcut target, and add the 
        // description. 
        psl->SetPath(lpszPathObj);
        psl->SetDescription(lpszDesc); 
		psl->SetWorkingDirectory(WorkDir);
 
       // Query IShellLink for the IPersistFile interface for saving the 
       // shortcut in persistent storage. 
        hres = psl->QueryInterface(IID_IPersistFile, (void **) &ppf);
 
        if (SUCCEEDED(hres)) { 
            WORD wsz[MAX_PATH]; 
 
            // Ensure that the string is ANSI. 
            MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, wsz, MAX_PATH); 

            // Save the link by calling IPersistFile::Save. 
            hres = ppf->Save(wsz, TRUE); 
            ppf->Release();
        } 
        psl->Release(); 
    } 

	_w(!SUCCEEDED(hres), MLS(LINK_FAIL), lpszDesc);
} 

//-----------------------------------------------------------------------------
// END OF FILE.
//-----------------------------------------------------------------------------
