// support english and russian messages.

enum lang_e
{
	LANG_RU,
	LANG_EN
};

int CurrentLang;

typedef struct 
{
	int control_id;
	char *caption;
} mls_t;

void SetLang(int Lang, mls_t *messages, int numof_msg, HWND hwnd)
{
	CurrentLang = Lang;
	for (int i = 1; i < numof_msg; ++i)
		SetDlgItemText(hwnd, messages[i].control_id, messages[i].caption);
	SetWindowText(hwnd, messages->caption);
	RedrawWindow(hwnd, NULL, NULL, RDW_UPDATENOW | RDW_INVALIDATE);
}

// messages:

enum mls_msg_e
{
	MLS_MSG_TITLE1,
	MLS_MSG_MEM,
	MLS_MSG_WRITE_INST,
	MLS_MSG_FILE_PTR,
	MLS_MSG_FILE_OPEN,
	MLS_MSG_FILE_READ,
	MLS_MSG_FILE_ATTR,
	MLS_MSG_SAVE_INST,
	MLS_MSG_NEW_INST,
	MLS_MSG_BAD_PATH,
	MLS_MSG_DONE,
	MLS_MSG_CHOOSE_DIR,
	MLS_MSG_COLOR_EX,
	MLS_MSG_OPEN_PROJ,
	MLS_MSG_SAVE_PROJ,
	MLS_MSG_LITE_MSG,
	MLS_MSG_EXIT,
	MLS_MSG_CHOOSE_A_LANG,
	MLS_MSG_CH_ICON,
	MLS_MSG_READ_ICON,
	MLS_MSG_BAD_ICON,
	MLS_MSG_IICO,
	MLS_MSG_COUNT
};

char * mls_msg_ru [MLS_MSG_COUNT] =
{
	"mInstaller ",
	"   ",
	"      ",
	"    ",
	"   : ",
	"   : ",
	"    : ",
	" ",
	"     ",
	"  (   ): ",
	"   .   "LOGFILE".        .",
	"    ",
	"                 .",
	"mInstaller:  ",
	"mInstaller:  ",
	"   ,    mInstaller "VERSION_NUM"   mrhx.narod.ru.  ?",
	"     ?    ?",
	"        ",
	"     (32x32, 16 )",
	"      ,    ",
	"  .  : 3232, 16 .",
	" "
};

char * mls_msg_en [MLS_MSG_COUNT] =
{
	"mInstaller ",
	"Memory allocation error",
	"File write error",
	"File pointer error",
	"File open error: ",
	"File read error: ",
	"Can`t get file attributes: ",
	"Save your installer",
	"Cannot create file for your installer",
	"Bad path (can`t get name of directory): ",
	"Your installer is done. Log file is "LOGFILE". It contents the log of the creating process.",
	"Choose a directory with your files",
	"This dialog window shows how the main window of your installer will be look. It uses the chosen style.",
	"mInstaller: Open a project",
	"mInstaller: Save the project",
	"In order to use this feature, download the full version of mInstaller "VERSION_NUM" from mrhx.narod.ru. Go there?",
	"Quit the program? Did You save all needed data?",
	"Choose at least one interface language for your installer",
	"Choose an icon for your installer (32x32, 16 colors)",
	"Could not read icon file, the default icon will be used",
	"Bad icon format. Must be: 32x32, 16 colors.",
	"Installer icon"
};

char ** mls_msg [2] = { mls_msg_ru, mls_msg_en };

#define MLS_MSG(name_)		mls_msg[CurrentLang][MLS_MSG_##name_]

// FOR MAIN WINDOW:

mls_t mls_main_ru [] =
{
 	0,				"mInstaller "VERSION":      !",
	IDC_STATIC_1,	"   (  ) ",
	IDC_STATIC_2,	"  ",
	IDC_OPEN_PROJ,	"...",
	IDC_SAVE_PROJ,	"...",
	IDC_COLORS,		"...",
	IDC_UNINST,		"",
	IDC_STATIC_3,	"   ",
	IDC_STATIC_4,	"      ",
	IDC_STATIC_5,	"  ,      ",
	IDC_STATIC_6,	"  :",
	IDC_STATIC_7,	"  :",
	IDC_STATIC_8,	"  :",
	IDC_STATIC_9,	"  :",
	IDC_STATIC_10,	"  :",
	IDC_STATIC_11,	"  :",
	IDC_STATIC_12,	"     ",
	IDC_STATIC_13,	" ,      ",
	IDC_STATIC_14,	"  :",
	IDC_STATIC_15,	" :",
	IDC_STATIC_16,	"    ",
	IDC_STATIC_17,	"     ",
	IDC_STATIC_18,	"   ",
	IDC_ICONPATH,	" ",
	IDC_INFO,		"",
	IDCANCEL,		"",
	IDC_OK,			" "
};

mls_t mls_main_en [] =
{
	0,				"mInstaller "VERSION": Create your own setup program at once!",
	IDC_STATIC_1,	" License text (conditions of program usage) ",
	IDC_STATIC_2,	" Project ",
	IDC_OPEN_PROJ,	"Open...",
	IDC_SAVE_PROJ,	"Save...",
	IDC_COLORS,		"Style...",
	IDC_UNINST,		"Uninstaller",
	IDC_STATIC_3,	" Program name ",
	IDC_STATIC_4,	" Directory with your program files ",
	IDC_STATIC_5,	" File names which it will create links for ",
	IDC_STATIC_6,	"On the Desktop:",
	IDC_STATIC_7,	"In Start menu:",
	IDC_STATIC_8,	"In Programs menu:",
	IDC_STATIC_9,	"In Autorun menu:",
	IDC_STATIC_10,	"On QuickLaunch panel:",
	IDC_STATIC_11,	"In SendTo menu:",
	IDC_STATIC_12,	" Default install path ",
	IDC_STATIC_13,	" File names which should be run after install ",
	IDC_STATIC_14,	"Program current language:",
	IDC_STATIC_15,	"Installer language:",
	IDC_STATIC_16,	" Password for setup ",
	IDC_STATIC_17,	" Folder in Programs menu ",
	IDC_STATIC_18,  " Producer name ",
	IDC_ICONPATH,	"Installer icon",
	IDC_INFO,		"Help",
	IDCANCEL,		"Close",
	IDC_OK,			"Create installer"
};

// FOR HELP WINDOW:

mls_t mls_help_ru [] =
{
	0, "  mInstaller",
	IDC_HELP_TEXT,
		"\r\n     :\r\n\r\n"
		"mInstaller, version "VERSION"\r\n\r\n"
		"(C) 2005-2007, Alexander G. Karpov a.k.a. mrhx\r\n\r\n"
		"  :   http://mrhx.narod.ru/\r\n\r\n"
		__DATE__", Saint Petersburg, Russia\r\n\r\n"
		"mInstaller - ,   , , "
		",        MS Windows"
		"       .\r\n"
		"\r\n      :\r\n"
		"\r\n1]    2.0, mInstaller     "
		"  ,        ."
		"     .  ,     "
		"   ,        "
		"      .\r\n\r\n"
		"     ,     "
		"  .       . "
		"        ,    . "
		"         . "
		"          ."
		"\r\n\r\n2]   ( )   . "
		"     , "
		"   ,      . "
		"       . : "
		"    16,       ."
		"\r\n\r\n3]    .       , "
		"    ."
		"\r\n\r\n4]     . "
		"           , "
		"     .\r\n"
		"\r\n5]      ( ,   ), "
		"      "
		"  ,   ,   /, "
		"  ,         "
		"(   )   . "
		"  ,    .    "
		"   /,        ,    "
		" /.\r\n\r\n   2.5, mInstaller     "
		"   .         . "
		"  ,          "
		"    .    ,      ."
		"\r\n\r\n"
		"   1.4,      , "
		"      :\r\n"
		"  1.  (          )\r\n"
		"  2. /_ (       )\r\n"
		"  3. /_/_ (    )\r\n"
		"\r\n6]    3.0,      .  ,     ,"
		"    ,         .\r\n"
		"\r\n7]     . "
		"       (    ).    Windows:\r\n"
		"  HOMEDRIVE=C:\r\n"
		"  HOMEPATH=\\\r\n"
		"  ProgramFiles=C:\\Program Files\r\n"
		"  SystemDrive=C:\r\n"
		"  SystemRoot=C:\\WINDOWS\r\n"
		"  winbootdir=C:\\WINDOWS\r\n"
		"  windir=C:\\WINDOWS\r\n"
		"  TEMP, TMP -    .\r\n"
		"        \"%ProgramFiles%\".\r\n"
		"       ,    . "
		"       . "
		" ,      . "
		" ,   'c:\\Program Files\\MyProg',   MyProg  , "
		"   ,    'Program Files'  ,       . "
		"  ,      .\r\n"
		"\r\n8] ,  ,  ,      . "
		"     ,   README,   ,  ,  . "
		"    (       ). "
		"      . "
		"  -  ,      4.  ,  ,      , "
		"       \".\" ().\r\n"
		"\r\n9]    3.0, mInstaller       . "
		"        .        .\r\n"
		"\r\n10]        .       .\r\n"
		"\r\n11]     . \r\n"
		"       ."
		"  (    -     ) "
		"   ,    . "
		"         . "
		"   mInstaller    mInstaller.log       , "
		"      ( ,   , "
		"     ,    ,   "
		"  .  100%,     ,    ).\r\n"
		"\r\n:\r\n"
		"  ,      "
		"( ZIP- ,     ). "
		"  (,    , "
		"    ) .\r\n\r\n"
		"        \r\n\r\n"
		"   3.5,        "
		"  .         . "
		"     ,     ( ,     ). "
		"      : 32x32, 16 ."
		"\r\n\r\n"
		"    \r\n\r\n"
		"   mInstaller 2.5   . "
		"  -    ,        "
		"(http://mrhx.narod.ru/).     ,   . "
		" mInstaller   1.2  .    mInstaller,     . "
		"        ,          . "
		"     ,     ''    .       "
		"  4 .     'uninst.exe'     .          ."
		"\r\n\r\n"
		"      \r\n\r\n"
		"mInstaller  .    "
		"(  )     ,     (+).    "
		"      .        . "
		"\r\n\r\n"
		"      :\r\n\r\n"
		",           , "
		" ,       .     . "
		"       .           . "
		"      mip (mInstaller Project),     .\r\n\r\n"
		"    :\r\n\r\n"
		"   .          ."
		"    ,    ."
		"\r\n\r\n    :\r\n\r\n"
		"  1. MS Windows 2000 SP4\r\n  2. MS Windows XP SP2\r\n  3. ReactOS v0.3.0 (http://www.reactos.org/)\r\n  4. Linux + wine"
		"\r\n\r\n               ,        ,   email ."
		"\r\n\r\nENJOY\r\n"
};

mls_t mls_help_en [] =
{
	0, "Help on mInstaller",
	IDC_HELP_TEXT,
		"\r\n    GENERAL INFORMATION:\r\n\r\n"
		"mInstaller, version "VERSION"\r\n\r\n"
		"(C) 2005-2007, Alexander G. Karpov a.k.a. mrhx\r\n\r\n"
		"Visit the author`s web site:   http://mrhx.narod.ru/\r\n\r\n"
		__DATE__", Saint Petersburg, Russia\r\n\r\n"
		"mInstaller - free of charge, easy to use, convenient, "
		"fast, the smallest tool to create setup programs under MS Windows "
		"with ability to change all the colors of setup windows.\r\n"
		"\r\n    SETUP CREATION:\r\n"
		"\r\n1] Since version 2.0, mInstaller allows to change all the colors of your installer."
		" and it also allows to add some effects to the main window of the installer."
		" These features are available via the STYLE button. Press it to open corresponding dialog window "
		"with a set of varied controls. Each of these controls is able to change view "
		"of the corresponding controlling element of your own setup program.\r\n\r\n"
		"In order to look an example of chosen style, press the DEMONSTRATE button. "
		"Press the USE button to save the style settings and close the dialog. "
		"If you want to discard the changes, press the CANCEL button. "
		"When the style settings dialog is just open, it shows the last saved style settings. "
		"When you save the current project, you also save the current style too."
		"\r\n\r\n2] Enter the license (conditions of usage) for your program or other useful information. "
		"This information will be shown to the user at the start of setup process. Note: "
		"The length of the license can be upto 16KBytes."
		"\r\n\r\n3] Specify the name of your program. It will be shown to the user while install and uninstall."
		"\r\n\r\n4] Choose a directory with your files. "
		"This directory and all its content will be installed in the user`s computer including "
		"all nested directories and files.\r\n"
		"\r\n5] Input the names of files and folders (without path, but with extension), "
		"which setup will create shortcuts for. It is able to create shortcuts "
		"on the Desktop, in the Start menu, in the Programs menu, "
		"in the Autorun menu, on the QuickLaunch panel and in the SendTo menu. "
		"That names must be separated with a comma. You may put here nothing. Each comma must be "
		"directly after the name. There may be any number of spaces after each comma."
		"\r\n\r\nSince version 2.5, mInstaller supports user-controls-shortcut feature. This is when the user is able to control specified shortcuts."
		"The checkboxes near the shortcut-edit fields is used for this purpose. "
		"If the checkbox is set, the user can choose whether create a shortcut or not. "
		"Otherwise the user will have no choice."
		"\r\n\r\n"
		"Since version 1.4, mInstaller supports the following formats of that lists. "
		"That formats allow to set more information for shortcuts:\r\n"
		"  1. FILENAME (name of shortcut and its description will be the same as the filename)\r\n"
		"  2. FILENAME/SHORTCUT_NAME (description of shortcut will be the same as its name)\r\n"
		"  3. FILENAME/SHORTCUT_NAME/SHORTCUT_DESCRIPTION (all supported information for shortcut)\r\n"
		"\r\n6] Since version 3.0, mInstaller is able to create a folder in Programs menu. Put the name of folder "
		"in the corresponding edit-field, if you need it.\r\n"
		"\r\n7] Enter the default install path. "
		"You may use the global environment variables in that path (each variable must be quoted with '%' characters). Here is some such variables:\r\n"
		"  HOMEDRIVE=C:\r\n"
		"  HOMEPATH=\\\r\n"
		"  ProgramFiles=C:\\Program Files\r\n"
		"  SystemDrive=C:\r\n"
		"  SystemRoot=C:\\WINDOWS\r\n"
		"  winbootdir=C:\\WINDOWS\r\n"
		"  windir=C:\\WINDOWS\r\n"
		"  TEMP, TMP - path for temporary files.\r\n"
		"Default value for this field is \"%ProgramFiles%\".\r\n"
		"If the specified path does not exist, it will be created. "
		"BUT, at the moment, mInstaller is able to create only single nonexistent directory. "
		"For example, if you set 'c:\\Program Files\\MyProg' as default install path and the folder 'MyProg' doesn`t exist, it will be created. "
		"But if 'Program Files' doesn`t exist, mInstaller can`t create it. "
		"In the last case, mInstaller asks the user to choose another directory.\r\n"
		"\r\n8] Set, if you need, a list of files, which mInstaller will open AFTER install done. "
		"This may be the main program file or README file or a name of directory and so on. "
		"Names must be separated with a comma (after each comma may be one or several spaces). "
		"Each name must be specified with path related to the current directory. "
		"The current directory is a directory which was set on the step #4. For example, if you want to show to the user all the content of installed directory, "
		"set the text \".\" (a dot) here.\r\n"
		"\r\n9] Since version 3.0, mInstaller allows to set the PASSWORD which the user must enter when installing. "
		"Without that password, user can not continue installing.\r\n"
		"\r\n10] You can enter the name of software producer into the corresponding edit field. It will be displayed while installing.\r\n"
		"\r\n11] Press the create-installer button. \r\n"
		"Then mInstaller shows the dialog window, in which you can choose where to save your new installer."
		"Over a couple of seconds, your setup program will be done. "
		"mInstaller shows the stage of process at the bottom of main window as a progress bar. "
		"mInstaller creates a log file 'mInstaller.log' in its work directory.\r\n"
		"\r\nNote:\r\n"
		"All the data will be compressed and encrypted (used zip-like compressing method)"
		"\r\n\r\n"
		"    CHANGING THE DEFAULT ICON OF SETUP PROGRAM\r\n\r\n"
		"Since version 3.5, there is an ability to change default icon of your setup program. "
		"Use the controls at the center of the main window for this. Note: the user icon must be in the following format: "
		"32x32, 16 colors."
		"\r\n\r\n"
		"    DE-INSTALLER\r\n\r\n"
		"Since version 2.5, mInstaller is able to create an uninstaller too. "
		"The uninstaller is a free program, which is accessable in the sources at the author`s web site "
		"(http://mrhx.narod.ru/). This tool is easy-to-use, small and fast. "
		"mInstaller contents version 1.2 of that uninstaller. "
		"To use that feature, set the UNINSTALLER checkbox. The size of uninstaller is just 4Kbytes. "
		"The filename of uninstaller is 'uninst.exe'. You can use that filename to create shortcuts for."
		"\r\n\r\n"
		"    OTHER LANGUAGES\r\n\r\n"
		"mInstaller supports two languages for user interface (russian+english). You can create installer (and uninstaller too) in Russian language or both English and Russian"
		". Use the checkboxes in the main window for that purpose."
		"\r\n\r\n"
		"    PROJECTS:\r\n\r\n"
		"All the data in the main window and current style can be saved as a project file "
		"in order to use it the next time. Use the SAVE button for this. If you want to open a project, use the OPEN button."
		"\r\n\r\n"
		"    SETUP PROCESS:\r\n\r\n"
		"Nonexistent files will be created. For already existent files, your setup will ask the user whether replace or skip."
		"\r\n\r\n    TESTED:\r\n\r\n"
		"  1. MS Windows 2000 SP4\r\n  2. MS Windows XP SP2\r\n  3. ReactOS v0.3.0 (http://www.reactos.org/)\r\n  4. Linux + wine"
		"\r\n\r\nIf you have found a bug or you have some wishes or notes about mInstaller, visit the author`s web site and leave there your messages, or send it to the author via email."
		"\r\n\r\nENJOY\r\n"

};

mls_t * mls_help [] = { mls_help_ru, mls_help_en };

// FOR COLORS WINDOW:

mls_t mls_colors_ru [] = 
{
	0,				" ",
	IDC_STATIC_1,	"  ",
	IDC_STATIC_2,	"          .       .",
	IDC_STATIC_3,	"  ",
	IDC_STYLE_DEF,	" - (   ) + ",
	IDC_STYLE_WIN,	" Windows",
	IDC_STYLE_USER,	"   (     )",
	IDC_STATIC_4,	"  ",
	IDC_STATIC_5,	" :",
	IDC_STATIC_6,	"   ",
	IDC_STATIC_7,	" :",
	IDC_STATIC_8,	"  ",
	IDC_STATIC_9,	" :",
	IDC_STATIC_10,	" :",
	IDC_STATIC_11,	" :",
	IDC_STATIC_12,	"  :",
	IDC_STATIC_13,	"  :",
	IDC_STATIC_14,	"    ",
	IDC_STATIC_15,	" :",
	IDC_STATIC_16,	"  :",
	IDC_STATIC_17,	"  ",
	IDC_STATIC_18,	" :",
	IDC_STATIC_19,	" :",
	IDC_STATIC_20,	"  ",
	IDC_STATIC_21,	"     ",
	IDC_NO_EFFECTS,			"",
	IDC_ROLLOUT_UPDOWN,		" ",
	IDC_ROLLOUT_LEFTRIGHT,	". ",
	IDC_ROLLOUT_CENTER,		".  ",
	IDCANCEL,				"",
	IDC_TEST,				"...",
	IDOK,					"",
	IDC_WINDOW_BACK,		"$$COLOR",
	IDC_EDIT_TEXT,			"$$COLOR",
	IDC_BUTTON_TEXT,		"$$COLOR",
	IDC_BUTTON_BACK,		"$$COLOR",
	IDC_BUTTON_BORDER,		"$$COLOR",
	IDC_BUTTON_LIGHTBACK,	"$$COLOR",
	IDC_BUTTON_DISBACK,		"$$COLOR",
	IDC_CHECK_TEXT,			"$$COLOR",
	IDC_CHECK_LIGHTTEXT,	"$$COLOR",
	IDC_GROUP_TEXT,			"$$COLOR",
	IDC_GROUP_BORDER,		"$$COLOR",
	IDC_TEXT_COLOR,			"$$COLOR"
};

mls_t mls_colors_en [] = 
{
	0, "Style settings",
	IDC_STATIC_1,	" Help ",
	IDC_STATIC_2,	"Here you can select color scheme of your installer. Style of this program is unchangable.",
	IDC_STATIC_3,	" Style ",
	IDC_STYLE_DEF,	"Default style (as in this program) + Effects",
	IDC_STYLE_WIN,	"Windows style",
	IDC_STYLE_USER,	"User style (use the following controls)",
	IDC_STATIC_4,	" Windows ",
	IDC_STATIC_5,	"Back color:",
	IDC_STATIC_6,	" Edits ",
	IDC_STATIC_7,	"Text color:",
	IDC_STATIC_8,	" Buttons ",
	IDC_STATIC_9,	"Text color:",
	IDC_STATIC_10,	"Back color:",
	IDC_STATIC_11,	"Border color:",
	IDC_STATIC_12,	"Lightback color:",
	IDC_STATIC_13,	"Disabled back color:",
	IDC_STATIC_14,	" Checkboxes ",
	IDC_STATIC_15,	"Text color:",
	IDC_STATIC_16,	"Light text color:",
	IDC_STATIC_17,	" Groups ",
	IDC_STATIC_18,	"Text colors:",
	IDC_STATIC_19,	"Border color:",
	IDC_STATIC_20,	" Text ",
	IDC_STATIC_21,	" Effects of main window ",
	IDC_NO_EFFECTS,			"None",
	IDC_ROLLOUT_UPDOWN,		"Show from the top",
	IDC_ROLLOUT_LEFTRIGHT,	"from the left",
	IDC_ROLLOUT_CENTER,		"from center",
	IDCANCEL,				"Cancel",
	IDC_TEST,				"Demonstrate...",
	IDOK,					"Use this settings",
	IDC_WINDOW_BACK,		"$$COLOR",
	IDC_EDIT_TEXT,			"$$COLOR",
	IDC_BUTTON_TEXT,		"$$COLOR",
	IDC_BUTTON_BACK,		"$$COLOR",
	IDC_BUTTON_BORDER,		"$$COLOR",
	IDC_BUTTON_LIGHTBACK,	"$$COLOR",
	IDC_BUTTON_DISBACK,		"$$COLOR",
	IDC_CHECK_TEXT,			"$$COLOR",
	IDC_CHECK_LIGHTTEXT,	"$$COLOR",
	IDC_GROUP_TEXT,			"$$COLOR",
	IDC_GROUP_BORDER,		"$$COLOR",
	IDC_TEXT_COLOR,			"$$COLOR"
};

mls_t * mls_colors [] = 
{
	mls_colors_ru, mls_colors_en
};


// color test dialog:

mls_t mls_ex_ru [] =
{
	0,				"   ",
	IDC_STATIC_1,	"     ",
	IDC_AGREE,		"   ( )",
	IDC_STATIC_2,	"  ,      ",
	IDC_STATIC_3,	"  :",
	IDC_STATIC_4,	"    :",
	IDC_CANCEL,		"",
	IDC_OK,			""
};

mls_t mls_ex_en [] =
{
	0,				"Example of chosen style",
	IDC_STATIC_1,	" Read the license attentively ",
	IDC_AGREE,		"Agree the license (conditions of usage)",
	IDC_STATIC_2,	" Choose a folder, which it will install into ",
	IDC_STATIC_3,	"Size of source files:",
	IDC_STATIC_4,	"Free size of specified drive:",
	IDC_CANCEL,		"Close",
	IDC_OK,			"Install"
};

mls_t * mls_ex [] = { mls_ex_ru, mls_ex_en };


////////////////////////////////////////
// MESSAGES FOR SETUP PROGRAM
////////////////////////////////////////

enum mls_e
{
	MLS_TITLE,
	MLS_OUT_OF_ORDER,
	MLS_DIR,
	MLS_LINK_FAIL,
	MLS_ABOUT_MI,
	MLS_NA,
	MLS_SETUP_TITLE,
	MLS_DONE,
	MLS_DONE_TITLE,
	MLS_NOT_AGREE,
	MLS_CHOOSE_DIR,
	MLS_SIGNATURE,
	MLS_MEM,
	MLS_FILE_READ,
	MLS_FILE_PTR,
	MLS_ERR_CD,
	MLS_FILE_OPEN,
	MLS_ERR_UNPACK_LICENSE,
	MLS_REG_ERR,
	MLS_UNINST_DAT,
	MLS_NEW_DIR_ERR,
	MLS_CANT_NEW_UNINST_DAT,
	MLS_BAD_UNPACK,
	MLS_CANT_NEW_FILE,
	MLS_CANT_WRITE_FILE,
	MLS_BAD_CODE,
	MLS_NO_COM,
	MLS_B,
	MLS_KB,
	MLS_MB,
	MLS_GB,
	MLS_ABOUT_INFO,

	// gui:
	// main:
	MLS_STATIC2,
	MLS_AGREE,
	MLS_STATIC3,
	MLS_STATIC1,
	MLS_STATIC4,
	MLS_CANCEL,
	MLS_LINKS,
	MLS_OK,

	// replace file:
	MLS_REPLACE_TITLE,
	MLS_R_STATIC1,
	MLS_R_STATIC2,
	MLS_R_STATIC3,
	MLS_R_OK,
	MLS_R_CANCEL,
	MLS_R_YES,
	MLS_R_NO,

	// links:
	MLS_LINKS_TITLE,
	MLS_L_STATIC1,
	MLS_L_STATIC2,
	MLS_L_CANCEL,
	MLS_L_USE,
	MLS_L_DESKTOP,
	MLS_L_START,
	MLS_L_PROGRAMS,
	MLS_L_AUTORUN,
	MLS_L_QUICK,
	MLS_L_SENDTO,

	// passwd:
	MLS_PASSWD_TITLE,
	MLS_P_OK,
	MLS_P_CANCEL,
	MLS_P_INFO,
	MLS_P_BAD,

	MLS_COUNT
};

char * mls_ru [MLS_COUNT] =
{
	"mInstaller",
	"  ",
	",   ,       .   .",
	"    \"%s\"",
	" ...",
	"<>",
	"  ",
	"   .",
	" ",
	"        ,         .",
	"   ",
	"   .   .",
	"   ",
	"    : ",
	"    ",
	"      \"%s\". , ,   .",
	"     : ",
	"      .      .",
	"    .  , ,  ",
	"         .    .",
	"    \"%s\".   .",
	"    \"%s\".      .",
	"   \"%s\". ,   .",
	"    \"%s\".   .",
	"    \"%s\".   .",
	"     . ,  .    .",
	"   COM.    .",
	"%u ",
	"%u,%u ",
	"%u,%u ",
	"%u,%u ",
		"mInstaller, version "VERSION"\n\n"
		"(C) 2005-2007, Alexander G. Karpov a.k.a. mrhx\n\n"
		"  :   http://mrhx.narod.ru\n\n"
		__DATE__", Saint Petersburg, Russia\n\n"
		"mInstaller - ,   , ,\n"
		",        Windows\n"
		"     .",

	// gui:
	// main:
	"     ",
	"   ( )",
	"  ,      ",
	"  :",
	"    :",
	"",
	"...",
	"",

	// replace file:
	"mInstaller:  ",
	"   ,    ?",
	":",
	" :",
	"&",
	"&",
	"&  ",
	"&  ",

	// links:
	" ",
	"  ",
	"       .       .",
	"",
	"",
	"  ",
	"  \"\"",
	"  \"\"",
	"  \"\"",
	"  \" \"",
	"  \"\"",

	// passwd:
	"",
	"",
	"",
	"    ,    .",
	",   , "
};

char * mls_en [MLS_COUNT] =
{
	"mInstaller",
	"Warning",
	"Directory you have chosen does not exist and cannot be created. Choose another one.",
	"Cannot create shortcut \"%s\"",
	"About the Installer...",
	"<N/A>",
	"Install program ",
	"Install complete successfully.",
	"Install complete",
	"Because you don`t agree the license, please close this program by pressing CLOSE button.",
	"Choose a directory for the program",
	"Cannot read the file signature. Bad setup.",
	"Memory allocation error",
	"Cannot read file: ",
	"File pointer move error.",
	"Can`t change current directory to \"%s\". The result may be incorrect.",
	"Cannot open file: ",
	"License is bad unpacked. Don`t worry.",
	"Registry failure. Shortcuts will be possibly invalid.",
	"Cannot write needed uninstall data. The uninstaller will not work properly.",
	"Cannot create folder \"%s\". The result will be incorrect.",
	"Cannot create file \"%s\". The uninstaller will not work properly.",
	"Bad unpacked file \"%s\". It is possibly broken.",
	"Cannot create file \"%s\". The result will be incorrect.",
	"Write file \"%s\" error. The result will be incorrect.",
	"Internal data error. The program is possibly broken. The result may be incorrect.",
	"COM init failed. Shortcuts are disabled.",
	"%u B",
	"%u,%u KB",
	"%u,%u MB",
	"%u,%u GB",
		"mInstaller, version "VERSION"\n\n"
		"(C) 2005-2007, Alexander G. Karpov a.k.a. mrhx\n\n"
		"Visit the author`s web site:   http://mrhx.narod.ru\n\n"
		__DATE__", Saint Petersburg, Russia\n\n"
		"mInstaller - free of charge, easy to use, convenient,\n"
		"fast, the smallest tool to create setup programs under MS Windows\n"
		"with ability to change all the colors of setup windows.",

	// gui:
	// main:
	" Read the license attentively ",
	"Agree the license (conditions of usage)",
	" Choose a folder, which it will install into ",
	"Size of source files:",
	"Free size of specified drive:",
	"Close",
	"Shortcuts...",
	"Install",

	// replace file:
	"mInstaller: replace a file",
	"The following file already exists. Replace?",
	"File:",
	"New size:",
	"&Yes",
	"&No",
	"Y&es for all",
	"N&o for all",

	// links:
	"Shortcut settings",
	" Help ",
	"The program you are installing allows to manage shortcuts.",
	"Cancel",
	"Use",
	"On the Desktop",
	"In Start menu",
	"In Programs menu",
	"In Autorun menu",
	"In QuickLaunch menu",
	"In SendTo menu",

	// passwd:
	"Password",
	"OK",
	"Cancel",
	"You must enter the valid password in order to install this program.",
	"The password you entered is invalid"
};

