// PROJECT OPEN & SAVE.

#define r(k,id) proj_str_read(This, k, id, buf, p)
#define ch(k,id) proj_check_read(This,k,id,buf)

void proj_str_read(HWND This, char *k, int id, char *buf, char *p)
{
	char b [16];
	lstrcat(lstrcpy(b, k), "n");
	*p = 0;
	UINT n = GetPrivateProfileInt("Project", b, 1, buf);
	GetPrivateProfileStruct("Project", k, p, n, buf);
	SetDlgItemText(This, id, p);
}

void proj_check_read(HWND This, char *k, int id, char *buf)
{
	if (GetPrivateProfileInt("Project", k, 0, buf) == 1)
		CheckDlgButton(This, id, BST_CHECKED);
}

void proj_open(HWND This)
{
	OPENFILENAME ofn;
	char buf [MAX_PATH];

	*buf = 0;
	ZeroMemory(&ofn, sizeof ofn);
	ofn.lStructSize	= sizeof ofn;
	ofn.Flags		= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_READONLY; // | OFN_ENABLEHOOK;
	ofn.lpstrFilter = "mInstaller Project (*.mip)\0*.mip\0All Files (*.*)\0*.*\0";
	ofn.lpstrFile	= buf;	
	ofn.nMaxFile	= MAX_PATH;
	ofn.lpstrTitle	= MLS_MSG(OPEN_PROJ);
	ofn.lpstrDefExt	= "mip";
	ofn.hwndOwner	= This;

	if (GetOpenFileName(&ofn))
	{
		char *p = GetMem(8001);

		r("l", IDC_LICENSE);
		r("s", IDC_DIR);
		r("1", IDC_LINKS_DESKTOP);
		r("2", IDC_LINKS_START_MENU);
		r("3", IDC_LINKS_PROGRAMS);
		r("4", IDC_LINKS_STARTUP);
		r("5", IDC_LINKS_QUICK_LAUNCH);
		r("6", IDC_LINKS_SENDTO);
		r("t", IDC_DEFAULT_INSTALL_PATH);
		r("r", IDC_RUN_LIST);
		r("pnm", IDC_PROGNAME);
		r("mfo", IDC_MENU_FOLDER);
		r("psw", IDC_PASSWD);
		r("prodc", IDC_PRODUCER);
		r("icop", IDC_ICONPATH);

		ch("un1", IDC_UNINST);
		ch("chd", IDC_CHECK_DESKTOP);
		ch("chs", IDC_CHECK_STARTMENU);
		ch("chp", IDC_CHECK_PROGRAMS);
		ch("chu", IDC_CHECK_STARTUP);
		ch("chq", IDC_CHECK_QUICKLAUNCH);
		ch("cht", IDC_CHECK_SENDTO);
		ch("lne", IDC_ILANG_EN);
		ch("lnr", IDC_ILANG_RU);

		Flags = GetPrivateProfileInt("Project", "flg", 0, buf);
#ifndef DISABLE_BW
		GetPrivateProfileStruct("Project", "stl", &UserStyle, sizeof(bwStyleStruct), buf);
#endif
		LocalFree(p);
	}
}

#undef r
#undef ch
#define w(k,v) WritePrivateProfileString("Project", k, v, buf)
#define c(k,id) proj_str_write(This,k,id,buf,p)
#define ch(k,id) proj_check_write(This,k,id,buf)

void proj_str_write(HWND This, char *k, int id, char *buf, char *p)
{
	char a [16], b[8];
	UINT size = 1+GetDlgItemText(This, id, p, 16000);
	WritePrivateProfileStruct("Project", k, p, size, buf);
	wsprintf(a, "%i", size);
	lstrcat(lstrcpy(b, k), "n");
	WritePrivateProfileString("Project", b, a, buf);
}

void proj_check_write(HWND This, char *k, int id, char *buf)
{
	char a [16];
	wsprintf(a, "%i", BST_CHECKED == IsDlgButtonChecked(This, id));
	WritePrivateProfileString("Project", k, a, buf);
}

void proj_save(HWND This)
{
	OPENFILENAME ofn;
	char buf [MAX_PATH];

	*buf = 0;
	ZeroMemory(&ofn, sizeof ofn);
	ofn.lStructSize	= sizeof ofn;
	ofn.Flags		= OFN_EXPLORER | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrFilter = "mInstaller Project (*.mip)\0*.mip\0All Files (*.*)\0*.*\0";
	ofn.lpstrFile	= buf;
	ofn.nMaxFile	= MAX_PATH;
	ofn.lpstrTitle	= MLS_MSG(SAVE_PROJ);
	ofn.lpstrDefExt	= "mip";
	ofn.hwndOwner	= This;

	if (GetSaveFileName(&ofn))
	{
		char *p = GetMem(16001);

		w("d", "mInstaller Project");
		w("v", VERSION);

		c("l", IDC_LICENSE);
		c("s", IDC_DIR);
		c("1", IDC_LINKS_DESKTOP);
		c("2", IDC_LINKS_START_MENU);
		c("3", IDC_LINKS_PROGRAMS);
		c("4", IDC_LINKS_STARTUP);
		c("5", IDC_LINKS_QUICK_LAUNCH);
		c("6", IDC_LINKS_SENDTO);
		c("t", IDC_DEFAULT_INSTALL_PATH);
		c("r", IDC_RUN_LIST);
		c("pnm", IDC_PROGNAME);
		c("mfo", IDC_MENU_FOLDER);
		c("psw", IDC_PASSWD);
		c("prodc", IDC_PRODUCER);
		c("icop", IDC_ICONPATH);

		ch("un1", IDC_UNINST);
		ch("chd", IDC_CHECK_DESKTOP);
		ch("chs", IDC_CHECK_STARTMENU);
		ch("chp", IDC_CHECK_PROGRAMS);
		ch("chu", IDC_CHECK_STARTUP);
		ch("chq", IDC_CHECK_QUICKLAUNCH);
		ch("cht", IDC_CHECK_SENDTO);
		ch("lne", IDC_ILANG_EN);
		ch("lnr", IDC_ILANG_RU);

		// write flags and colors:
		wsprintf(p, "%i", Flags);
		WritePrivateProfileString("Project", "flg", p, buf);
#ifndef DISABLE_BW
		WritePrivateProfileStruct("Project", "stl", &UserStyle, sizeof(bwStyleStruct), buf);
#endif
		LocalFree(p);
	}
}

#undef w
#undef c
#undef ch
